const char * lj_coul_long = 

"#define _texture(name, type)  texture<type> name\n"
"#define _texture_2d(name, type) texture<type,1> name\n"
"#ifdef USE_HIP\n"
"  #include <hip/hip_runtime.h>\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define mul24(x, y) __mul24(x, y)\n"
"    #undef _texture\n"
"    #undef _texture_2d\n"
"    #define _texture(name, type)  __device__ type* name\n"
"    #define _texture_2d(name, type)  __device__ type* name\n"
"  #endif\n"
"  #define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"  #define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"  #define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"  #define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"  #define THREAD_ID_X threadIdx.x\n"
"  #define THREAD_ID_Y threadIdx.y\n"
"  #define BLOCK_ID_X blockIdx.x\n"
"  #define BLOCK_ID_Y blockIdx.y\n"
"  #define BLOCK_SIZE_X blockDim.x\n"
"  #define BLOCK_SIZE_Y blockDim.y\n"
"  #define __kernel extern \"C\" __global__\n"
"  #ifdef __local\n"
"    #undef __local\n"
"  #endif\n"
"  #define __local __shared__\n"
"  #define __global\n"
"  #define restrict __restrict__\n"
"  #define atom_add atomicAdd\n"
"  #define ucl_inline static __inline__ __device__\n"
"  #define THREADS_PER_ATOM 4\n"
"  #define THREADS_PER_CHARGE 8\n"
"  #define BLOCK_NBOR_BUILD 128\n"
"  #define BLOCK_PAIR 256\n"
"  #define BLOCK_BIO_PAIR 256\n"
"  #define BLOCK_ELLIPSE 128\n"
"  #define MAX_SHARED_TYPES 11\n"
"  #ifdef _SINGLE_SINGLE\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      return __shfl_xor(var, laneMask, width);\n"
"  #else\n"
"      return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"  #endif\n"
"    }\n"
"  #else\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"      int2 tmp;\n"
"      tmp.x = __double2hiint(var);\n"
"      tmp.y = __double2loint(var);\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  #else\n"
"      tmp.x = __shfl_xor_sync(0xffffffff, tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor_sync(0xffffffff, tmp.y,laneMask,width);\n"
"  #endif\n"
"      return __hiloint2double(tmp.x,tmp.y);\n"
"    }\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define ARCH 600\n"
"    #define WARP_SIZE 64\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #define ARCH __CUDA_ARCH__\n"
"    #define WARP_SIZE 32\n"
"  #endif\n"
"  #define fast_mul(X,Y) (X)*(Y)\n"
"  #define MEM_THREADS WARP_SIZE\n"
"  #define PPPM_BLOCK_1D 64\n"
"  #define BLOCK_CELL_2D 8\n"
"  #define BLOCK_CELL_ID 128\n"
"  #define MAX_BIO_SHARED_TYPES 128\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) {                        \\\n"
"        int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"        int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"        ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"        ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"        ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"        ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"      }\n"
"      #define fetch(ans,i,q_tex) {                           \\\n"
"        int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"        ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"      }\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"      #define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"    #endif\n"
"  #else\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((double4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((double *)  q_tex) + i))\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((float4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((float *)  q_tex) + i))\n"
"    #endif\n"
"  #endif\n"
"  #ifdef _DOUBLE_DOUBLE\n"
"    #define ucl_exp exp\n"
"    #define ucl_powr pow\n"
"    #define ucl_atan atan\n"
"    #define ucl_cbrt cbrt\n"
"    #define ucl_ceil ceil\n"
"    #define ucl_abs fabs\n"
"    #define ucl_rsqrt rsqrt\n"
"    #define ucl_sqrt sqrt\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"  #else\n"
"    #define ucl_atan atanf\n"
"    #define ucl_cbrt cbrtf\n"
"    #define ucl_ceil ceilf\n"
"    #define ucl_abs fabsf\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"    #define ucl_rsqrt rsqrtf\n"
"    #define ucl_sqrt sqrtf\n"
"    #ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"      #define ucl_exp expf\n"
"      #define ucl_powr powf\n"
"    #else\n"
"      #define ucl_exp __expf\n"
"      #define ucl_powr __powf\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"    \n"
"#ifdef NV_KERNEL\n"
"#define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"#define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"#define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"#define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"#define THREAD_ID_X threadIdx.x\n"
"#define THREAD_ID_Y threadIdx.y\n"
"#define BLOCK_ID_X blockIdx.x\n"
"#define BLOCK_ID_Y blockIdx.y\n"
"#define BLOCK_SIZE_X blockDim.x\n"
"#define BLOCK_SIZE_Y blockDim.y\n"
"#define __kernel extern \"C\" __global__\n"
"#define __local __shared__\n"
"#define __global\n"
"#define restrict __restrict__\n"
"#define atom_add atomicAdd\n"
"#define ucl_inline static __inline__ __device__\n"
"#ifdef __CUDA_ARCH__\n"
"#define ARCH __CUDA_ARCH__\n"
"#else\n"
"#define ARCH 100\n"
"#endif\n"
"#if (ARCH < 200)\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 16\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_PAIR 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#if (ARCH < 300)\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 256\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#if (__CUDACC_VER_MAJOR__ < 9)\n"
"#ifdef _SINGLE_SINGLE\n"
"#define shfl_xor __shfl_xor\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#else\n"
"#ifdef _SINGLE_SINGLE\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"}\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor_sync(0xffffffff,tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor_sync(0xffffffff,tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define fetch4(ans,i,pos_tex) {                        \\\n"
"  int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"  int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"  ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"  ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"  ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"  ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"}\n"
"#define fetch(ans,i,q_tex) {                           \\\n"
"  int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"  ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"}\n"
"#else\n"
"#define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"#define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"#endif\n"
"#if (__CUDA_ARCH__ < 200)\n"
"#define fast_mul __mul24\n"
"#define MEM_THREADS 16\n"
"#else\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define MEM_THREADS 32\n"
"#endif\n"
"#ifdef CUDA_PRE_THREE\n"
"struct __builtin_align__(16) _double4\n"
"{\n"
"  double x, y, z, w;\n"
"};\n"
"typedef struct _double4 double4;\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define ucl_exp exp\n"
"#define ucl_powr pow\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_atan atanf\n"
"#define ucl_cbrt cbrtf\n"
"#define ucl_ceil ceilf\n"
"#define ucl_abs fabsf\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#define ucl_rsqrt rsqrtf\n"
"#define ucl_sqrt sqrtf\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp expf\n"
"#define ucl_powr powf\n"
"#else\n"
"#define ucl_exp __expf\n"
"#define ucl_powr __powf\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef NV_GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define fast_mul mul24\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef FERMI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef KEPLER_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 256\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifndef NO_OCL_PTX\n"
"#define ARCH 300\n"
"#ifdef _SINGLE_SINGLE\n"
"inline float shfl_xor(float var, int laneMask, int width) {\n"
"  float ret;\n"
"  int c;\n"
"  c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=f\"(ret) : \"f\"(var), \"r\"(laneMask), \"r\"(c));\n"
"  return ret;\n"
"}\n"
"#else\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  int x,y,x2,y2;\n"
"  double ans;\n"
"  asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(x2) : \"r\"(x), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(y2) : \"r\"(y), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"  return ans;\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef CYPRESS_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 64\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef INTEL_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 1\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 4\n"
"#define BLOCK_BIO_PAIR 2\n"
"#define BLOCK_ELLIPSE 2\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 1\n"
"#define BLOCK_CELL_ID 2\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef PHI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 16\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 16\n"
"#define BLOCK_BIO_PAIR 16\n"
"#define BLOCK_ELLIPSE 16\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 4\n"
"#define BLOCK_CELL_ID 16\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef USE_OPENCL\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#ifndef fast_mul\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#endif\n"
"#ifndef ARCH\n"
"#define ARCH 0\n"
"#endif\n"
"#ifndef DRIVER\n"
"#define DRIVER 0\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define NO_HARDWARE_TRANSCENDENTALS\n"
"#endif\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#endif\n"
"#endif\n"
"#ifndef PPPM_MAX_SPLINE\n"
"#define PPPM_MAX_SPLINE 8\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#ifndef BLOCK_ELLIPSE\n"
"#define BLOCK_ELLIPSE BLOCK_PAIR\n"
"#endif\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    red_acc[4][tid]=e_coul;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<5; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    e_coul=red_acc[4][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#else\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"      e_coul += shfl_xor(e_coul, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_aux_fun1.h\"\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex,float4);\n"
"_texture( q_tex,float);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"_texture( q_tex,int2);\n"
"#endif\n"
"#else\n"
"#define pos_tex x_\n"
"#define q_tex q_\n"
"#endif\n"
"__kernel void k_lj_coul_long(const __global numtyp4 *restrict x_,\n"
"                             const __global numtyp4 *restrict lj1,\n"
"                             const __global numtyp4 *restrict lj3,\n"
"                             const int lj_types,\n"
"                             const __global numtyp *restrict sp_lj_in,\n"
"                             const __global int *dev_nbor,\n"
"                             const __global int *dev_packed,\n"
"                             __global acctyp4 *restrict ans,\n"
"                             __global acctyp *restrict engv,\n"
"                             const int eflag, const int vflag, const int inum,\n"
"                             const int nbor_pitch,\n"
"                             const __global numtyp *restrict q_,\n"
"                             const numtyp cut_coulsq, const numtyp qqrd2e,\n"
"                             const numtyp g_ewald, const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp sp_lj[8];\n"
"  sp_lj[0]=sp_lj_in[0];\n"
"  sp_lj[1]=sp_lj_in[1];\n"
"  sp_lj[2]=sp_lj_in[2];\n"
"  sp_lj[3]=sp_lj_in[3];\n"
"  sp_lj[4]=sp_lj_in[4];\n"
"  sp_lj[5]=sp_lj_in[5];\n"
"  sp_lj[6]=sp_lj_in[6];\n"
"  sp_lj[7]=sp_lj_in[7];\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp e_coul=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    numtyp qtmp; fetch(qtmp,i,q_tex);\n"
"    int itype=ix.w;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      numtyp factor_lj, factor_coul;\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      factor_coul = (numtyp)1.0-sp_lj[sbmask(j)+4];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      int mtype=itype*lj_types+jtype;\n"
"      if (rsq<lj1[mtype].z) {\n"
"        numtyp r2inv=ucl_recip(rsq);\n"
"        numtyp forcecoul, force_lj, force, r6inv, prefactor, _erfc;\n"
"        if (rsq < lj1[mtype].w) {\n"
"          r6inv = r2inv*r2inv*r2inv;\n"
"          force_lj = factor_lj*r6inv*(lj1[mtype].x*r6inv-lj1[mtype].y);\n"
"        } else\n"
"          force_lj = (numtyp)0.0;\n"
"        if (rsq < cut_coulsq) {\n"
"          numtyp r = ucl_rsqrt(r2inv);\n"
"          numtyp grij = g_ewald * r;\n"
"          numtyp expm2 = ucl_exp(-grij*grij);\n"
"          numtyp t = ucl_recip((numtyp)1.0 + EWALD_P*grij);\n"
"          _erfc = t * (A1+t*(A2+t*(A3+t*(A4+t*A5)))) * expm2;\n"
"          fetch(prefactor,j,q_tex);\n"
"          prefactor *= qqrd2e * qtmp/r;\n"
"          forcecoul = prefactor * (_erfc + EWALD_F*grij*expm2-factor_coul);\n"
"        } else\n"
"          forcecoul = (numtyp)0.0;\n"
"        force = (force_lj + forcecoul) * r2inv;\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (eflag>0) {\n"
"          if (rsq < cut_coulsq)\n"
"            e_coul += prefactor*(_erfc-factor_coul);\n"
"          if (rsq < lj1[mtype].w) {\n"
"            numtyp e=r6inv*(lj3[mtype].x*r6inv-lj3[mtype].y);\n"
"            energy+=factor_lj*(e-lj3[mtype].z);\n"
"          }\n"
"        }\n"
"        if (vflag>0) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    } \n"
"    store_answers_q(f,energy,e_coul,virial,ii,inum,tid,t_per_atom,offset,eflag,\n"
"                    vflag,ans,engv);\n"
"  } \n"
"}\n"
"__kernel void k_lj_coul_long_fast(const __global numtyp4 *restrict x_,\n"
"                                  const __global numtyp4 *restrict lj1_in,\n"
"                                  const __global numtyp4 *restrict lj3_in,\n"
"                                  const __global numtyp *restrict sp_lj_in,\n"
"                                  const __global int *dev_nbor,\n"
"                                  const __global int *dev_packed,\n"
"                                  __global acctyp4 *restrict ans,\n"
"                                  __global acctyp *restrict engv,\n"
"                                  const int eflag, const int vflag,\n"
"                                  const int inum,  const int nbor_pitch,\n"
"                                  const __global numtyp *restrict q_,\n"
"                                  const numtyp cut_coulsq, const numtyp qqrd2e,\n"
"                                  const numtyp g_ewald, const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp4 lj1[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  __local numtyp4 lj3[MAX_SHARED_TYPES*MAX_SHARED_TYPES];\n"
"  __local numtyp sp_lj[8];\n"
"  if (tid<8)\n"
"    sp_lj[tid]=sp_lj_in[tid];\n"
"  if (tid<MAX_SHARED_TYPES*MAX_SHARED_TYPES) {\n"
"    lj1[tid]=lj1_in[tid];\n"
"    if (eflag>0)\n"
"      lj3[tid]=lj3_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp e_coul=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    numtyp qtmp; fetch(qtmp,i,q_tex);\n"
"    int iw=ix.w;\n"
"    int itype=fast_mul((int)MAX_SHARED_TYPES,iw);\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      numtyp factor_lj, factor_coul;\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      factor_coul = (numtyp)1.0-sp_lj[sbmask(j)+4];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int mtype=itype+jx.w;\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      if (rsq<lj1[mtype].z) {\n"
"        numtyp r2inv=ucl_recip(rsq);\n"
"        numtyp forcecoul, force_lj, force, r6inv, prefactor, _erfc;\n"
"        if (rsq < lj1[mtype].w) {\n"
"          r6inv = r2inv*r2inv*r2inv;\n"
"          force_lj = factor_lj*r6inv*(lj1[mtype].x*r6inv-lj1[mtype].y);\n"
"        } else\n"
"          force_lj = (numtyp)0.0;\n"
"        if (rsq < cut_coulsq) {\n"
"          numtyp r = ucl_rsqrt(r2inv);\n"
"          numtyp grij = g_ewald * r;\n"
"          numtyp expm2 = ucl_exp(-grij*grij);\n"
"          numtyp t = ucl_recip((numtyp)1.0 + EWALD_P*grij);\n"
"          _erfc = t * (A1+t*(A2+t*(A3+t*(A4+t*A5)))) * expm2;\n"
"          fetch(prefactor,j,q_tex);\n"
"          prefactor *= qqrd2e * qtmp/r;\n"
"          forcecoul = prefactor * (_erfc + EWALD_F*grij*expm2-factor_coul);\n"
"        } else\n"
"          forcecoul = (numtyp)0.0;\n"
"        force = (force_lj + forcecoul) * r2inv;\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (eflag>0) {\n"
"          if (rsq < cut_coulsq)\n"
"            e_coul += prefactor*(_erfc-factor_coul);\n"
"          if (rsq < lj1[mtype].w) {\n"
"            numtyp e=r6inv*(lj3[mtype].x*r6inv-lj3[mtype].y);\n"
"            energy+=factor_lj*(e-lj3[mtype].z);\n"
"          }\n"
"        }\n"
"        if (vflag>0) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    } \n"
"    store_answers_q(f,energy,e_coul,virial,ii,inum,tid,t_per_atom,offset,eflag,\n"
"                    vflag,ans,engv);\n"
"  } \n"
"}\n"
;
