const char * re_squared = 

"#define _texture(name, type)  texture<type> name\n"
"#define _texture_2d(name, type) texture<type,1> name\n"
"#ifdef USE_HIP\n"
"  #include <hip/hip_runtime.h>\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define mul24(x, y) __mul24(x, y)\n"
"    #undef _texture\n"
"    #undef _texture_2d\n"
"    #define _texture(name, type)  __device__ type* name\n"
"    #define _texture_2d(name, type)  __device__ type* name\n"
"  #endif\n"
"  #define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"  #define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"  #define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"  #define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"  #define THREAD_ID_X threadIdx.x\n"
"  #define THREAD_ID_Y threadIdx.y\n"
"  #define BLOCK_ID_X blockIdx.x\n"
"  #define BLOCK_ID_Y blockIdx.y\n"
"  #define BLOCK_SIZE_X blockDim.x\n"
"  #define BLOCK_SIZE_Y blockDim.y\n"
"  #define __kernel extern \"C\" __global__\n"
"  #ifdef __local\n"
"    #undef __local\n"
"  #endif\n"
"  #define __local __shared__\n"
"  #define __global\n"
"  #define restrict __restrict__\n"
"  #define atom_add atomicAdd\n"
"  #define ucl_inline static __inline__ __device__\n"
"  #define THREADS_PER_ATOM 4\n"
"  #define THREADS_PER_CHARGE 8\n"
"  #define BLOCK_NBOR_BUILD 128\n"
"  #define BLOCK_PAIR 256\n"
"  #define BLOCK_BIO_PAIR 256\n"
"  #define BLOCK_ELLIPSE 128\n"
"  #define MAX_SHARED_TYPES 11\n"
"  #ifdef _SINGLE_SINGLE\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      return __shfl_xor(var, laneMask, width);\n"
"  #else\n"
"      return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"  #endif\n"
"    }\n"
"  #else\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"      int2 tmp;\n"
"      tmp.x = __double2hiint(var);\n"
"      tmp.y = __double2loint(var);\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  #else\n"
"      tmp.x = __shfl_xor_sync(0xffffffff, tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor_sync(0xffffffff, tmp.y,laneMask,width);\n"
"  #endif\n"
"      return __hiloint2double(tmp.x,tmp.y);\n"
"    }\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define ARCH 600\n"
"    #define WARP_SIZE 64\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #define ARCH __CUDA_ARCH__\n"
"    #define WARP_SIZE 32\n"
"  #endif\n"
"  #define fast_mul(X,Y) (X)*(Y)\n"
"  #define MEM_THREADS WARP_SIZE\n"
"  #define PPPM_BLOCK_1D 64\n"
"  #define BLOCK_CELL_2D 8\n"
"  #define BLOCK_CELL_ID 128\n"
"  #define MAX_BIO_SHARED_TYPES 128\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) {                        \\\n"
"        int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"        int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"        ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"        ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"        ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"        ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"      }\n"
"      #define fetch(ans,i,q_tex) {                           \\\n"
"        int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"        ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"      }\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"      #define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"    #endif\n"
"  #else\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((double4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((double *)  q_tex) + i))\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((float4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((float *)  q_tex) + i))\n"
"    #endif\n"
"  #endif\n"
"  #ifdef _DOUBLE_DOUBLE\n"
"    #define ucl_exp exp\n"
"    #define ucl_powr pow\n"
"    #define ucl_atan atan\n"
"    #define ucl_cbrt cbrt\n"
"    #define ucl_ceil ceil\n"
"    #define ucl_abs fabs\n"
"    #define ucl_rsqrt rsqrt\n"
"    #define ucl_sqrt sqrt\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"  #else\n"
"    #define ucl_atan atanf\n"
"    #define ucl_cbrt cbrtf\n"
"    #define ucl_ceil ceilf\n"
"    #define ucl_abs fabsf\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"    #define ucl_rsqrt rsqrtf\n"
"    #define ucl_sqrt sqrtf\n"
"    #ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"      #define ucl_exp expf\n"
"      #define ucl_powr powf\n"
"    #else\n"
"      #define ucl_exp __expf\n"
"      #define ucl_powr __powf\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"    \n"
"#ifdef NV_KERNEL\n"
"#define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"#define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"#define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"#define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"#define THREAD_ID_X threadIdx.x\n"
"#define THREAD_ID_Y threadIdx.y\n"
"#define BLOCK_ID_X blockIdx.x\n"
"#define BLOCK_ID_Y blockIdx.y\n"
"#define BLOCK_SIZE_X blockDim.x\n"
"#define BLOCK_SIZE_Y blockDim.y\n"
"#define __kernel extern \"C\" __global__\n"
"#define __local __shared__\n"
"#define __global\n"
"#define restrict __restrict__\n"
"#define atom_add atomicAdd\n"
"#define ucl_inline static __inline__ __device__\n"
"#ifdef __CUDA_ARCH__\n"
"#define ARCH __CUDA_ARCH__\n"
"#else\n"
"#define ARCH 100\n"
"#endif\n"
"#if (ARCH < 200)\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 16\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_PAIR 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#if (ARCH < 300)\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 256\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#if (__CUDACC_VER_MAJOR__ < 9)\n"
"#ifdef _SINGLE_SINGLE\n"
"#define shfl_xor __shfl_xor\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#else\n"
"#ifdef _SINGLE_SINGLE\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"}\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor_sync(0xffffffff,tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor_sync(0xffffffff,tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define fetch4(ans,i,pos_tex) {                        \\\n"
"  int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"  int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"  ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"  ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"  ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"  ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"}\n"
"#define fetch(ans,i,q_tex) {                           \\\n"
"  int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"  ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"}\n"
"#else\n"
"#define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"#define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"#endif\n"
"#if (__CUDA_ARCH__ < 200)\n"
"#define fast_mul __mul24\n"
"#define MEM_THREADS 16\n"
"#else\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define MEM_THREADS 32\n"
"#endif\n"
"#ifdef CUDA_PRE_THREE\n"
"struct __builtin_align__(16) _double4\n"
"{\n"
"  double x, y, z, w;\n"
"};\n"
"typedef struct _double4 double4;\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define ucl_exp exp\n"
"#define ucl_powr pow\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_atan atanf\n"
"#define ucl_cbrt cbrtf\n"
"#define ucl_ceil ceilf\n"
"#define ucl_abs fabsf\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#define ucl_rsqrt rsqrtf\n"
"#define ucl_sqrt sqrtf\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp expf\n"
"#define ucl_powr powf\n"
"#else\n"
"#define ucl_exp __expf\n"
"#define ucl_powr __powf\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef NV_GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define fast_mul mul24\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef FERMI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef KEPLER_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 256\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifndef NO_OCL_PTX\n"
"#define ARCH 300\n"
"#ifdef _SINGLE_SINGLE\n"
"inline float shfl_xor(float var, int laneMask, int width) {\n"
"  float ret;\n"
"  int c;\n"
"  c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=f\"(ret) : \"f\"(var), \"r\"(laneMask), \"r\"(c));\n"
"  return ret;\n"
"}\n"
"#else\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  int x,y,x2,y2;\n"
"  double ans;\n"
"  asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(x2) : \"r\"(x), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(y2) : \"r\"(y), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"  return ans;\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef CYPRESS_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 64\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef INTEL_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 1\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 4\n"
"#define BLOCK_BIO_PAIR 2\n"
"#define BLOCK_ELLIPSE 2\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 1\n"
"#define BLOCK_CELL_ID 2\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef PHI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 16\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 16\n"
"#define BLOCK_BIO_PAIR 16\n"
"#define BLOCK_ELLIPSE 16\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 4\n"
"#define BLOCK_CELL_ID 16\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef USE_OPENCL\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#ifndef fast_mul\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#endif\n"
"#ifndef ARCH\n"
"#define ARCH 0\n"
"#endif\n"
"#ifndef DRIVER\n"
"#define DRIVER 0\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define NO_HARDWARE_TRANSCENDENTALS\n"
"#endif\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#endif\n"
"#endif\n"
"#ifndef PPPM_MAX_SPLINE\n"
"#define PPPM_MAX_SPLINE 8\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#ifndef BLOCK_ELLIPSE\n"
"#define BLOCK_ELLIPSE BLOCK_PAIR\n"
"#endif\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    red_acc[4][tid]=e_coul;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<5; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    e_coul=red_acc[4][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#else\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"      e_coul += shfl_xor(e_coul, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#endif\n"

"#ifndef LAL_ELLIPSOID_EXTRA_H\n"
"#define LAL_ELLIPSOID_EXTRA_H\n"
"enum{SPHERE_SPHERE,SPHERE_ELLIPSE,ELLIPSE_SPHERE,ELLIPSE_ELLIPSE};\n"
"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_aux_fun1.h\"\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex, float4);\n"
"_texture( quat_tex,float4);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"_texture_2d( quat_tex,int4);\n"
"#endif\n"
"#else\n"
"#define pos_tex x_\n"
"#define quat_tex qif\n"
"#endif\n"
"#define nbor_info_e(nbor_mem, nbor_stride, t_per_atom, ii, offset,           \\\n"
"                    i, numj, stride, nbor_end, nbor_begin)                   \\\n"
"    i=nbor_mem[ii];                                                          \\\n"
"    nbor_begin=ii+nbor_stride;                                               \\\n"
"    numj=nbor_mem[nbor_begin];                                               \\\n"
"    nbor_begin+=nbor_stride;                                                 \\\n"
"    nbor_end=nbor_begin+fast_mul(nbor_stride,numj);                          \\\n"
"    nbor_begin+=fast_mul(offset,nbor_stride);                                \\\n"
"    stride=fast_mul(t_per_atom,nbor_stride);\n"
"#if (ARCH < 300)\n"
"#define store_answers_t(f, tor, energy, virial, ii, astride, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[7][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=tor.x;                                                  \\\n"
"    red_acc[4][tid]=tor.y;                                                  \\\n"
"    red_acc[5][tid]=tor.z;                                                  \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<6; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    tor.x=red_acc[3][tid];                                                  \\\n"
"    tor.y=red_acc[4][tid];                                                  \\\n"
"    tor.z=red_acc[5][tid];                                                  \\\n"
"    if (eflag>0 || vflag>0) {                                               \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      red_acc[6][tid]=energy;                                               \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<7; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"      energy=red_acc[6][tid];                                               \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    __global acctyp *ap1=engv+ii;                                           \\\n"
"    if (eflag>0) {                                                          \\\n"
"      *ap1=energy*(acctyp)0.5;                                              \\\n"
"      ap1+=astride;                                                         \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        *ap1=virial[i]*(acctyp)0.5;                                         \\\n"
"        ap1+=astride;                                                       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"    ans[ii+astride]=tor;                                                    \\\n"
"  }\n"
"#define acc_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset,   \\\n"
"                    eflag, vflag, ans, engv)                                \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    engv+=ii;                                                               \\\n"
"    if (eflag>0) {                                                          \\\n"
"      *engv+=energy*(acctyp)0.5;                                            \\\n"
"      engv+=inum;                                                           \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        *engv+=virial[i]*(acctyp)0.5;                                       \\\n"
"        engv+=inum;                                                         \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#else\n"
"#define store_answers_t(f, tor, energy, virial, ii, astride, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        tor.x += shfl_xor(tor.x, s, t_per_atom);                            \\\n"
"        tor.y += shfl_xor(tor.y, s, t_per_atom);                            \\\n"
"        tor.z += shfl_xor(tor.z, s, t_per_atom);                            \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    __global acctyp *ap1=engv+ii;                                           \\\n"
"    if (eflag>0) {                                                          \\\n"
"      *ap1=energy*(acctyp)0.5;                                              \\\n"
"      ap1+=astride;                                                         \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        *ap1=virial[i]*(acctyp)0.5;                                         \\\n"
"        ap1+=astride;                                                       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"    ans[ii+astride]=tor;                                                    \\\n"
"  }\n"
"#define acc_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset,   \\\n"
"                    eflag, vflag, ans, engv)                                \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    engv+=ii;                                                               \\\n"
"    if (eflag>0) {                                                          \\\n"
"      *engv+=energy*(acctyp)0.5;                                            \\\n"
"      engv+=inum;                                                           \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        *engv+=virial[i]*(acctyp)0.5;                                       \\\n"
"        engv+=inum;                                                         \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#endif\n"
"/* ----------------------------------------------------------------------\n"
"   dot product of 2 vectors\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline numtyp gpu_dot3(const numtyp *v1, const numtyp *v2)\n"
"{\n"
"  return v1[0]*v2[0]+v1[1]*v2[1]+v1[2]*v2[2];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   cross product of 2 vectors\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_cross3(const numtyp *v1, const numtyp *v2, numtyp *ans)\n"
"{\n"
"  ans[0] = v1[1]*v2[2]-v1[2]*v2[1];\n"
"  ans[1] = v1[2]*v2[0]-v1[0]*v2[2];\n"
"  ans[2] = v1[0]*v2[1]-v1[1]*v2[0];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   determinant of a matrix\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline numtyp gpu_det3(const numtyp m[9])\n"
"{\n"
"  numtyp ans = m[0]*m[4]*m[8] - m[0]*m[5]*m[7] -\n"
"    m[3]*m[1]*m[8] + m[3]*m[2]*m[7] +\n"
"    m[6]*m[1]*m[5] - m[6]*m[2]*m[4];\n"
"  return ans;\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   diagonal matrix times a full matrix\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_diag_times3(const numtyp4 shape, const numtyp m[9],\n"
"                              numtyp ans[9])\n"
"{\n"
"  ans[0] = shape.x*m[0];\n"
"  ans[1] = shape.x*m[1];\n"
"  ans[2] = shape.x*m[2];\n"
"  ans[3] = shape.y*m[3];\n"
"  ans[4] = shape.y*m[4];\n"
"  ans[5] = shape.y*m[5];\n"
"  ans[6] = shape.z*m[6];\n"
"  ans[7] = shape.z*m[7];\n"
"  ans[8] = shape.z*m[8];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   add two matrices\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_plus3(const numtyp m[9], const numtyp m2[9], numtyp ans[9])\n"
"{\n"
"  ans[0] = m[0]+m2[0];\n"
"  ans[1] = m[1]+m2[1];\n"
"  ans[2] = m[2]+m2[2];\n"
"  ans[3] = m[3]+m2[3];\n"
"  ans[4] = m[4]+m2[4];\n"
"  ans[5] = m[5]+m2[5];\n"
"  ans[6] = m[6]+m2[6];\n"
"  ans[7] = m[7]+m2[7];\n"
"  ans[8] = m[8]+m2[8];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   multiply the transpose of mat1 times mat2\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_transpose_times3(const numtyp m[9], const numtyp m2[9],\n"
"                                   numtyp ans[9])\n"
"{\n"
"  ans[0] = m[0]*m2[0]+m[3]*m2[3]+m[6]*m2[6];\n"
"  ans[1] = m[0]*m2[1]+m[3]*m2[4]+m[6]*m2[7];\n"
"  ans[2] = m[0]*m2[2]+m[3]*m2[5]+m[6]*m2[8];\n"
"  ans[3] = m[1]*m2[0]+m[4]*m2[3]+m[7]*m2[6];\n"
"  ans[4] = m[1]*m2[1]+m[4]*m2[4]+m[7]*m2[7];\n"
"  ans[5] = m[1]*m2[2]+m[4]*m2[5]+m[7]*m2[8];\n"
"  ans[6] = m[2]*m2[0]+m[5]*m2[3]+m[8]*m2[6];\n"
"  ans[7] = m[2]*m2[1]+m[5]*m2[4]+m[8]*m2[7];\n"
"  ans[8] = m[2]*m2[2]+m[5]*m2[5]+m[8]*m2[8];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   row vector times matrix\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_row_times3(const numtyp *v, const numtyp m[9], numtyp *ans)\n"
"{\n"
"  ans[0] = m[0]*v[0]+v[1]*m[3]+v[2]*m[6];\n"
"  ans[1] = v[0]*m[1]+m[4]*v[1]+v[2]*m[7];\n"
"  ans[2] = v[0]*m[2]+v[1]*m[5]+m[8]*v[2];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   solve Ax = b or M ans = v\n"
"   use gaussian elimination & partial pivoting on matrix\n"
"   error_flag set to 2 if bad matrix inversion attempted\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_mldivide3(const numtyp m[9], const numtyp *v, numtyp *ans,\n"
"                            __global int *error_flag)\n"
"{\n"
"  \n"
"  numtyp aug[12], t;\n"
"  aug[3] = v[0];\n"
"  aug[0] = m[0];\n"
"  aug[1] = m[1];\n"
"  aug[2] = m[2];\n"
"  aug[7] = v[1];\n"
"  aug[4] = m[3];\n"
"  aug[5] = m[4];\n"
"  aug[6] = m[5];\n"
"  aug[11] = v[2];\n"
"  aug[8] = m[6];\n"
"  aug[9] = m[7];\n"
"  aug[10] = m[8];\n"
"  if (ucl_abs(aug[4]) > ucl_abs(aug[0])) {\n"
"    numtyp swapt;\n"
"    swapt=aug[0]; aug[0]=aug[4]; aug[4]=swapt;\n"
"    swapt=aug[1]; aug[1]=aug[5]; aug[5]=swapt;\n"
"    swapt=aug[2]; aug[2]=aug[6]; aug[6]=swapt;\n"
"    swapt=aug[3]; aug[3]=aug[7]; aug[7]=swapt;\n"
"  }\n"
"  if (ucl_abs(aug[8]) > ucl_abs(aug[0])) {\n"
"    numtyp swapt;\n"
"    swapt=aug[0]; aug[0]=aug[8]; aug[8]=swapt;\n"
"    swapt=aug[1]; aug[1]=aug[9]; aug[9]=swapt;\n"
"    swapt=aug[2]; aug[2]=aug[10]; aug[10]=swapt;\n"
"    swapt=aug[3]; aug[3]=aug[11]; aug[11]=swapt;\n"
"  }\n"
"  if (aug[0] != (numtyp)0.0) {\n"
"    if (0!=0) {\n"
"      numtyp swapt;\n"
"      swapt=aug[0]; aug[0]=aug[0]; aug[0]=swapt;\n"
"      swapt=aug[1]; aug[1]=aug[1]; aug[1]=swapt;\n"
"      swapt=aug[2]; aug[2]=aug[2]; aug[2]=swapt;\n"
"      swapt=aug[3]; aug[3]=aug[3]; aug[3]=swapt;\n"
"    }\n"
"  } else if (aug[4] != (numtyp)0.0) {\n"
"    if (1!=0) {\n"
"      numtyp swapt;\n"
"      swapt=aug[0]; aug[0]=aug[4]; aug[4]=swapt;\n"
"      swapt=aug[1]; aug[1]=aug[5]; aug[5]=swapt;\n"
"      swapt=aug[2]; aug[2]=aug[6]; aug[6]=swapt;\n"
"      swapt=aug[3]; aug[3]=aug[7]; aug[7]=swapt;\n"
"    }\n"
"  } else if (aug[8] != (numtyp)0.0) {\n"
"    if (2!=0) {\n"
"      numtyp swapt;\n"
"      swapt=aug[0]; aug[0]=aug[8]; aug[8]=swapt;\n"
"      swapt=aug[1]; aug[1]=aug[9]; aug[9]=swapt;\n"
"      swapt=aug[2]; aug[2]=aug[10]; aug[10]=swapt;\n"
"      swapt=aug[3]; aug[3]=aug[11]; aug[11]=swapt;\n"
"    }\n"
"  } else\n"
"    *error_flag=2;\n"
"  t = aug[4]/aug[0];\n"
"  aug[5]-=t*aug[1];\n"
"  aug[6]-=t*aug[2];\n"
"  aug[7]-=t*aug[3];\n"
"  t = aug[8]/aug[0];\n"
"  aug[9]-=t*aug[1];\n"
"  aug[10]-=t*aug[2];\n"
"  aug[11]-=t*aug[3];\n"
"  if (ucl_abs(aug[9]) > ucl_abs(aug[5])) {\n"
"    numtyp swapt;\n"
"    swapt=aug[4]; aug[4]=aug[8]; aug[8]=swapt;\n"
"    swapt=aug[5]; aug[5]=aug[9]; aug[9]=swapt;\n"
"    swapt=aug[6]; aug[6]=aug[10]; aug[10]=swapt;\n"
"    swapt=aug[7]; aug[7]=aug[11]; aug[11]=swapt;\n"
"  }\n"
"  if (aug[5] != (numtyp)0.0) {\n"
"    if (1!=1) {\n"
"      numtyp swapt;\n"
"      swapt=aug[4]; aug[4]=aug[4]; aug[4]=swapt;\n"
"      swapt=aug[5]; aug[5]=aug[5]; aug[5]=swapt;\n"
"      swapt=aug[6]; aug[6]=aug[6]; aug[6]=swapt;\n"
"      swapt=aug[7]; aug[7]=aug[7]; aug[7]=swapt;\n"
"    }\n"
"  } else if (aug[9] != (numtyp)0.0) {\n"
"    if (2!=1) {\n"
"      numtyp swapt;\n"
"      swapt=aug[4]; aug[4]=aug[8]; aug[8]=swapt;\n"
"      swapt=aug[5]; aug[5]=aug[9]; aug[9]=swapt;\n"
"      swapt=aug[6]; aug[6]=aug[10]; aug[10]=swapt;\n"
"      swapt=aug[7]; aug[7]=aug[11]; aug[11]=swapt;\n"
"    }\n"
"  }\n"
"  t = aug[9]/aug[5];\n"
"  aug[10]-=t*aug[6];\n"
"  aug[11]-=t*aug[7];\n"
"  if (aug[10] == (numtyp)0.0)\n"
"    *error_flag=2;\n"
"  ans[2] = aug[11]/aug[10];\n"
"  t = (numtyp)0.0;\n"
"  t += aug[6]*ans[2];\n"
"  ans[1] = (aug[7]-t) / aug[5];\n"
"  t = (numtyp)0.0;\n"
"  t += aug[1]*ans[1];\n"
"  t += aug[2]*ans[2];\n"
"  ans[0] = (aug[3]-t) / aug[0];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   compute rotation matrix from quaternion conjugate\n"
"   quat = [w i j k]\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_quat_to_mat_trans(__global const numtyp4 *qif, const int qi,\n"
"                                    numtyp mat[9])\n"
"{\n"
"  numtyp4 q; fetch4(q,qi,quat_tex);\n"
"  numtyp w2 = q.x*q.x;\n"
"  numtyp i2 = q.y*q.y;\n"
"  numtyp j2 = q.z*q.z;\n"
"  numtyp k2 = q.w*q.w;\n"
"  numtyp twoij = (numtyp)2.0*q.y*q.z;\n"
"  numtyp twoik = (numtyp)2.0*q.y*q.w;\n"
"  numtyp twojk = (numtyp)2.0*q.z*q.w;\n"
"  numtyp twoiw = (numtyp)2.0*q.y*q.x;\n"
"  numtyp twojw = (numtyp)2.0*q.z*q.x;\n"
"  numtyp twokw = (numtyp)2.0*q.w*q.x;\n"
"  mat[0] = w2+i2-j2-k2;\n"
"  mat[3] = twoij-twokw;\n"
"  mat[6] = twojw+twoik;\n"
"  mat[1] = twoij+twokw;\n"
"  mat[4] = w2-i2+j2-k2;\n"
"  mat[7] = twojk-twoiw;\n"
"  mat[2] = twoik-twojw;\n"
"  mat[5] = twojk+twoiw;\n"
"  mat[8] = w2-i2-j2+k2;\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   transposed matrix times diagonal matrix\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_transpose_times_diag3(const numtyp m[9],\n"
"                                        const numtyp4 d, numtyp ans[9])\n"
"{\n"
"  ans[0] = m[0]*d.x;\n"
"  ans[1] = m[3]*d.y;\n"
"  ans[2] = m[6]*d.z;\n"
"  ans[3] = m[1]*d.x;\n"
"  ans[4] = m[4]*d.y;\n"
"  ans[5] = m[7]*d.z;\n"
"  ans[6] = m[2]*d.x;\n"
"  ans[7] = m[5]*d.y;\n"
"  ans[8] = m[8]*d.z;\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   multiply mat1 times mat2\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_times3(const numtyp m[9], const numtyp m2[9],\n"
"                         numtyp ans[9])\n"
"{\n"
"  ans[0] = m[0]*m2[0] + m[1]*m2[3] + m[2]*m2[6];\n"
"  ans[1] = m[0]*m2[1] + m[1]*m2[4] + m[2]*m2[7];\n"
"  ans[2] = m[0]*m2[2] + m[1]*m2[5] + m[2]*m2[8];\n"
"  ans[3] = m[3]*m2[0] + m[4]*m2[3] + m[5]*m2[6];\n"
"  ans[4] = m[3]*m2[1] + m[4]*m2[4] + m[5]*m2[7];\n"
"  ans[5] = m[3]*m2[2] + m[4]*m2[5] + m[5]*m2[8];\n"
"  ans[6] = m[6]*m2[0] + m[7]*m2[3] + m[8]*m2[6];\n"
"  ans[7] = m[6]*m2[1] + m[7]*m2[4] + m[8]*m2[7];\n"
"  ans[8] = m[6]*m2[2] + m[7]*m2[5] + m[8]*m2[8];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   Apply principal rotation generator about x to rotation matrix m\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_rotation_generator_x(const numtyp m[9], numtyp ans[9])\n"
"{\n"
"  ans[0] = 0;\n"
"  ans[1] = -m[2];\n"
"  ans[2] = m[1];\n"
"  ans[3] = 0;\n"
"  ans[4] = -m[5];\n"
"  ans[5] = m[4];\n"
"  ans[6] = 0;\n"
"  ans[7] = -m[8];\n"
"  ans[8] = m[7];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   Apply principal rotation generator about y to rotation matrix m\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_rotation_generator_y(const numtyp m[9], numtyp ans[9])\n"
"{\n"
"  ans[0] = m[2];\n"
"  ans[1] = 0;\n"
"  ans[2] = -m[0];\n"
"  ans[3] = m[5];\n"
"  ans[4] = 0;\n"
"  ans[5] = -m[3];\n"
"  ans[6] = m[8];\n"
"  ans[7] = 0;\n"
"  ans[8] = -m[6];\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   Apply principal rotation generator about z to rotation matrix m\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_rotation_generator_z(const numtyp m[9], numtyp ans[9])\n"
"{\n"
"  ans[0] = -m[1];\n"
"  ans[1] = m[0];\n"
"  ans[2] = 0;\n"
"  ans[3] = -m[4];\n"
"  ans[4] = m[3];\n"
"  ans[5] = 0;\n"
"  ans[6] = -m[7];\n"
"  ans[7] = m[6];\n"
"  ans[8] = 0;\n"
"};\n"
"/* ----------------------------------------------------------------------\n"
"   matrix times vector\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void gpu_times_column3(const numtyp m[9], const numtyp v[3],\n"
"                                numtyp ans[3])\n"
"{\n"
"  ans[0] = m[0]*v[0] + m[1]*v[1] + m[2]*v[2];\n"
"  ans[1] = m[3]*v[0] + m[4]*v[1] + m[5]*v[2];\n"
"  ans[2] = m[6]*v[0] + m[7]*v[1] + m[8]*v[2];\n"
"};\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_ellipsoid_extra.h\"\n"
"#endif\n"
"ucl_inline numtyp det_prime(const numtyp m[9], const numtyp m2[9])\n"
"{\n"
"  numtyp ans;\n"
"  ans = m2[0]*m[4]*m[8] - m2[0]*m[5]*m[7] -\n"
"        m[3]*m2[1]*m[8] + m[3]*m2[2]*m[7] +\n"
"        m[6]*m2[1]*m[5] - m[6]*m2[2]*m[4] +\n"
"        m[0]*m2[4]*m[8] - m[0]*m2[5]*m[7] -\n"
"        m2[3]*m[1]*m[8] + m2[3]*m[2]*m[7] +\n"
"        m[6]*m[1]*m2[5] - m[6]*m[2]*m2[4] +\n"
"        m[0]*m[4]*m2[8] - m[0]*m[5]*m2[7] -\n"
"        m[3]*m[1]*m2[8] + m[3]*m[2]*m2[7] +\n"
"        m2[6]*m[1]*m[5] - m2[6]*m[2]*m[4];\n"
"  return ans;\n"
"}\n"
"__kernel void k_resquared(const __global numtyp4 *restrict x_,\n"
"                          const __global numtyp4 *restrict q,\n"
"                          const __global numtyp4 *restrict shape,\n"
"                          const __global numtyp4 *restrict well,\n"
"                          const __global numtyp *restrict splj,\n"
"                          const __global numtyp2 *restrict sig_eps,\n"
"                          const int ntypes,\n"
"                          const __global int *dev_nbor,\n"
"                          const int stride,\n"
"                          __global acctyp4 *restrict ans,\n"
"                          const int astride,\n"
"                          __global acctyp *restrict engv,\n"
"                          __global int *restrict err_flag,\n"
"                          const int eflag, const int vflag, const int inum,\n"
"                          const int t_per_atom) {\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp sp_lj[4];\n"
"  sp_lj[0]=splj[0];\n"
"  sp_lj[1]=splj[1];\n"
"  sp_lj[2]=splj[2];\n"
"  sp_lj[3]=splj[3];\n"
"  __local numtyp b_alpha, cr60;\n"
"  b_alpha=(numtyp)45.0/(numtyp)56.0;\n"
"  cr60=ucl_cbrt((numtyp)60.0);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0;\n"
"  f.y=(acctyp)0;\n"
"  f.z=(acctyp)0;\n"
"  acctyp4 tor;\n"
"  tor.x=(acctyp)0;\n"
"  tor.y=(acctyp)0;\n"
"  tor.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    __local int n_stride;\n"
"    nbor_info_e(dev_nbor,stride,t_per_atom,ii,offset,i,numj,\n"
"                n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex);\n"
"    int itype=ix.w;\n"
"    numtyp a1[9];       \n"
"    numtyp aTe1[9];     \n"
"    numtyp gamma1[9];   \n"
"    numtyp sa1[9];      \n"
"    numtyp lA1_0[9], lA1_1[9], lA1_2[9]; \n"
"    numtyp lAtwo1_0[9], lAtwo1_1[9], lAtwo1_2[9];  \n"
"    numtyp lAsa1_0[9], lAsa1_1[9], lAsa1_2[9];   \n"
"    numtyp4 ishape;\n"
"    ishape=shape[itype];\n"
"    numtyp4 ishape2;\n"
"    ishape2.x=ishape.x*ishape.x;\n"
"    ishape2.y=ishape.y*ishape.y;\n"
"    ishape2.z=ishape.z*ishape.z;\n"
"    numtyp ilshape = ishape.x*ishape.y*ishape.z;\n"
"    {\n"
"      numtyp aTs[9];    \n"
"      gpu_quat_to_mat_trans(q,i,a1);\n"
"      gpu_transpose_times_diag3(a1,well[itype],aTe1);\n"
"      gpu_transpose_times_diag3(a1,ishape2,aTs);\n"
"      gpu_diag_times3(ishape2,a1,sa1);\n"
"      gpu_times3(aTs,a1,gamma1);\n"
"      gpu_rotation_generator_x(a1,lA1_0);\n"
"      gpu_rotation_generator_y(a1,lA1_1);\n"
"      gpu_rotation_generator_z(a1,lA1_2);\n"
"      gpu_times3(aTs,lA1_0,lAtwo1_0);\n"
"      gpu_transpose_times3(lA1_0,sa1,lAsa1_0);\n"
"      gpu_plus3(lAsa1_0,lAtwo1_0,lAsa1_0);\n"
"      gpu_times3(aTs,lA1_1,lAtwo1_1);\n"
"      gpu_transpose_times3(lA1_1,sa1,lAsa1_1);\n"
"      gpu_plus3(lAsa1_1,lAtwo1_1,lAsa1_1);\n"
"      gpu_times3(aTs,lA1_2,lAtwo1_2);\n"
"      gpu_transpose_times3(lA1_2,sa1,lAsa1_2);\n"
"      gpu_plus3(lAsa1_2,lAtwo1_2,lAsa1_2);\n"
"    }\n"
"    ishape2.x=ucl_recip(ishape2.x);\n"
"    ishape2.y=ucl_recip(ishape2.y);\n"
"    ishape2.z=ucl_recip(ishape2.z);\n"
"    numtyp factor_lj;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_nbor[nbor];\n"
"      factor_lj = sp_lj[sbmask(j)];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex);\n"
"      int jtype=jx.w;\n"
"      \n"
"      numtyp r[3], rhat[3];\n"
"      numtyp rnorm;\n"
"      r[0] = jx.x-ix.x;\n"
"      r[1] = jx.y-ix.y;\n"
"      r[2] = jx.z-ix.z;\n"
"      rnorm = gpu_dot3(r,r);\n"
"      rnorm = ucl_rsqrt(rnorm);\n"
"      rhat[0] = r[0]*rnorm;\n"
"      rhat[1] = r[1]*rnorm;\n"
"      rhat[2] = r[2]*rnorm;\n"
"      numtyp a2[9];       \n"
"      numtyp gamma2[9];   \n"
"      numtyp4 jshape;\n"
"      jshape=shape[jtype];\n"
"      numtyp4 jshape2;\n"
"      jshape2.x=jshape.x*jshape.x;\n"
"      jshape2.y=jshape.y*jshape.y;\n"
"      jshape2.z=jshape.z*jshape.z;\n"
"      {\n"
"        numtyp aTs[9];    \n"
"        gpu_quat_to_mat_trans(q,j,a2);\n"
"        gpu_transpose_times_diag3(a2,jshape2,aTs);\n"
"        gpu_times3(aTs,a2,gamma2);\n"
"      }\n"
"      numtyp temp[9], s[3], z1[3], z2[3], v1[3], v2[3];\n"
"      numtyp sigma12, sigma1, sigma2;\n"
"      gpu_plus3(gamma1,gamma2,temp);\n"
"      gpu_mldivide3(temp,rhat,s,err_flag);\n"
"      sigma12 = ucl_rsqrt((numtyp)0.5*gpu_dot3(s,rhat));\n"
"      gpu_times_column3(a1,rhat,z1);\n"
"      gpu_times_column3(a2,rhat,z2);\n"
"      v1[0] = z1[0]*ishape2.x;\n"
"      v1[1] = z1[1]*ishape2.y;\n"
"      v1[2] = z1[2]*ishape2.z;\n"
"      v2[0] = z2[0]/jshape2.x;\n"
"      v2[1] = z2[1]/jshape2.y;\n"
"      v2[2] = z2[2]/jshape2.z;\n"
"      sigma1 = ucl_sqrt(gpu_dot3(z1,v1));\n"
"      sigma2 = ucl_sqrt(gpu_dot3(z2,v2));\n"
"      numtyp H12[9];\n"
"      numtyp dH;\n"
"      H12[0] = gamma1[0]*sigma1+gamma2[0]*sigma2;\n"
"      H12[1] = gamma1[1]*sigma1+gamma2[1]*sigma2;\n"
"      H12[2] = gamma1[2]*sigma1+gamma2[2]*sigma2;\n"
"      H12[3] = gamma1[3]*sigma1+gamma2[3]*sigma2;\n"
"      H12[4] = gamma1[4]*sigma1+gamma2[4]*sigma2;\n"
"      H12[5] = gamma1[5]*sigma1+gamma2[5]*sigma2;\n"
"      H12[6] = gamma1[6]*sigma1+gamma2[6]*sigma2;\n"
"      H12[7] = gamma1[7]*sigma1+gamma2[7]*sigma2;\n"
"      H12[8] = gamma1[8]*sigma1+gamma2[8]*sigma2;\n"
"      dH=gpu_det3(H12);\n"
"      numtyp sigma1p2, sigma2p2, lambda, nu;\n"
"      sigma1p2 = sigma1*sigma1;\n"
"      sigma2p2 = sigma2*sigma2;\n"
"      numtyp jlshape = jshape.x*jshape.y*jshape.z;\n"
"      lambda = ilshape*sigma1p2 + jlshape*sigma2p2;\n"
"      sigma1=ucl_recip(sigma1);\n"
"      sigma2=ucl_recip(sigma2);\n"
"      nu = ucl_rsqrt((sigma1+sigma2)/dH);\n"
"      gpu_times3(aTe1,a1,temp);\n"
"      numtyp sigma, epsilon;\n"
"      int mtype=fast_mul(ntypes,itype)+jtype;\n"
"      sigma = sig_eps[mtype].x;\n"
"      epsilon = sig_eps[mtype].y*factor_lj;\n"
"      numtyp w[3], temp2[9];\n"
"      numtyp h12,eta,chi,sprod,sigh,tprod;\n"
"      numtyp aTe2[9];     \n"
"      gpu_transpose_times_diag3(a2,well[jtype],aTe2);\n"
"      gpu_times3(aTe2,a2,temp2);\n"
"      gpu_plus3(temp,temp2,temp);\n"
"      gpu_mldivide3(temp,rhat,w,err_flag);\n"
"      h12 = ucl_recip(rnorm)-sigma12;\n"
"      eta = lambda/nu;\n"
"      chi = (numtyp)2.0*gpu_dot3(rhat,w);\n"
"      sprod = ilshape * jlshape;\n"
"      sigh = sigma/h12;\n"
"      tprod = eta*chi*sigh;\n"
"      numtyp stemp, Ua;\n"
"      stemp = h12*(numtyp)0.5;\n"
"      Ua = (ishape.x+stemp)*(ishape.y+stemp)*\n"
"           (ishape.z+stemp)*(jshape.x+stemp)*\n"
"           (jshape.y+stemp)*(jshape.z+stemp);\n"
"      Ua = ((numtyp)1.0+(numtyp)3.0*tprod)*sprod/Ua;\n"
"      Ua = epsilon*Ua/(numtyp)-36.0;\n"
"      numtyp Ur;\n"
"      stemp = h12/cr60;\n"
"      Ur = (ishape.x+stemp)*(ishape.y+stemp)*\n"
"           (ishape.z+stemp)*(jshape.x+stemp)*\n"
"           (jshape.y+stemp)*(jshape.z+stemp);\n"
"      Ur = ((numtyp)1.0+b_alpha*tprod)*sprod/Ur;\n"
"      numtyp sigh6=sigh*sigh*sigh;\n"
"      sigh6*=sigh6;\n"
"      Ur = epsilon*Ur*sigh6/(numtyp)2025.0;\n"
"      energy+=Ua+Ur;\n"
"      \n"
"      numtyp vsigma1[3], vsigma2[3], gsigma1[9], gsigma2[9];\n"
"      numtyp sec, sigma12p3, sigma1p3, sigma2p3;\n"
"      sec = sigma*eta*chi;\n"
"      sigma12p3 = sigma12*sigma12*sigma12;\n"
"      sigma1p3 = sigma1/sigma1p2;\n"
"      sigma2p3 = sigma2/sigma2p2;\n"
"      vsigma1[0] = -sigma1p3*v1[0];\n"
"      vsigma1[1] = -sigma1p3*v1[1];\n"
"      vsigma1[2] = -sigma1p3*v1[2];\n"
"      vsigma2[0] = -sigma2p3*v2[0];\n"
"      vsigma2[1] = -sigma2p3*v2[1];\n"
"      vsigma2[2] = -sigma2p3*v2[2];\n"
"      gsigma1[0] = -gamma1[0]*sigma1p2;\n"
"      gsigma1[1] = -gamma1[1]*sigma1p2;\n"
"      gsigma1[2] = -gamma1[2]*sigma1p2;\n"
"      gsigma1[3] = -gamma1[3]*sigma1p2;\n"
"      gsigma1[4] = -gamma1[4]*sigma1p2;\n"
"      gsigma1[5] = -gamma1[5]*sigma1p2;\n"
"      gsigma1[6] = -gamma1[6]*sigma1p2;\n"
"      gsigma1[7] = -gamma1[7]*sigma1p2;\n"
"      gsigma1[8] = -gamma1[8]*sigma1p2;\n"
"      gsigma2[0] = -gamma2[0]*sigma2p2;\n"
"      gsigma2[1] = -gamma2[1]*sigma2p2;\n"
"      gsigma2[2] = -gamma2[2]*sigma2p2;\n"
"      gsigma2[3] = -gamma2[3]*sigma2p2;\n"
"      gsigma2[4] = -gamma2[4]*sigma2p2;\n"
"      gsigma2[5] = -gamma2[5]*sigma2p2;\n"
"      gsigma2[6] = -gamma2[6]*sigma2p2;\n"
"      gsigma2[7] = -gamma2[7]*sigma2p2;\n"
"      gsigma2[8] = -gamma2[8]*sigma2p2;\n"
"      numtyp tsig1sig2, tdH, teta1, teta2;\n"
"      numtyp fourw[3], spr[3];\n"
"      tsig1sig2 = eta/((numtyp)2.0*(sigma1+sigma2));\n"
"      tdH = eta/((numtyp)2.0*dH);\n"
"      teta1 = (numtyp)2.0*eta/lambda;\n"
"      teta2 = teta1*jlshape/sigma2p3;\n"
"      teta1 = teta1*ilshape/sigma1p3;\n"
"      fourw[0] = (numtyp)4.0*w[0];\n"
"      fourw[1] = (numtyp)4.0*w[1];\n"
"      fourw[2] = (numtyp)4.0*w[2];\n"
"      spr[0] = (numtyp)0.5*sigma12p3*s[0];\n"
"      spr[1] = (numtyp)0.5*sigma12p3*s[1];\n"
"      spr[2] = (numtyp)0.5*sigma12p3*s[2];\n"
"      numtyp hsec, dspu, pbsu;\n"
"      stemp = ucl_recip(ishape.x*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.y*(numtyp)2.0+h12)+\n"
"              ucl_recip(ishape.z*(numtyp)2.0+h12)+\n"
"              ucl_recip(jshape.x*(numtyp)2.0+h12)+\n"
"              ucl_recip(jshape.y*(numtyp)2.0+h12)+\n"
"              ucl_recip(jshape.z*(numtyp)2.0+h12);\n"
"      hsec = ucl_recip(h12+(numtyp)3.0*sec);\n"
"      dspu = ucl_recip(h12)-hsec+stemp;\n"
"      pbsu = (numtyp)3.0*sigma*hsec;\n"
"      numtyp dspr, pbsr;\n"
"      stemp = ucl_recip(ishape.x*cr60+h12)+\n"
"              ucl_recip(ishape.y*cr60+h12)+\n"
"              ucl_recip(ishape.z*cr60+h12)+\n"
"              ucl_recip(jshape.x*cr60+h12)+\n"
"              ucl_recip(jshape.y*cr60+h12)+\n"
"              ucl_recip(jshape.z*cr60+h12);\n"
"      hsec = ucl_recip(h12+b_alpha*sec);\n"
"      dspr = (numtyp)7.0/h12-hsec+stemp;\n"
"      pbsr = b_alpha*sigma*hsec;\n"
"      numtyp dH12[9];\n"
"      numtyp dUa, dUr, deta, dchi, ddH, dh12;\n"
"      numtyp dsigma1, dsigma2;\n"
"      #pragma unroll\n"
"      for (int i=0; i<3; i++) {\n"
"        numtyp u[3], u1[3], u2[3];\n"
"        u[0] = -rhat[i]*rhat[0];\n"
"        u[1] = -rhat[i]*rhat[1];\n"
"        u[2] = -rhat[i]*rhat[2];\n"
"        u[i] += (numtyp)1.0;\n"
"        u[0] *= rnorm;\n"
"        u[1] *= rnorm;\n"
"        u[2] *= rnorm;\n"
"        gpu_times_column3(a1,u,u1);\n"
"        gpu_times_column3(a2,u,u2);\n"
"        dsigma1=gpu_dot3(u1,vsigma1);\n"
"        dsigma2=gpu_dot3(u2,vsigma2);\n"
"        dH12[0] = dsigma1*gsigma1[0]+dsigma2*gsigma2[0];\n"
"        dH12[1] = dsigma1*gsigma1[1]+dsigma2*gsigma2[1];\n"
"        dH12[2] = dsigma1*gsigma1[2]+dsigma2*gsigma2[2];\n"
"        dH12[3] = dsigma1*gsigma1[3]+dsigma2*gsigma2[3];\n"
"        dH12[4] = dsigma1*gsigma1[4]+dsigma2*gsigma2[4];\n"
"        dH12[5] = dsigma1*gsigma1[5]+dsigma2*gsigma2[5];\n"
"        dH12[6] = dsigma1*gsigma1[6]+dsigma2*gsigma2[6];\n"
"        dH12[7] = dsigma1*gsigma1[7]+dsigma2*gsigma2[7];\n"
"        dH12[8] = dsigma1*gsigma1[8]+dsigma2*gsigma2[8];\n"
"        ddH = det_prime(H12,dH12);\n"
"        deta = (dsigma1+dsigma2)*tsig1sig2;\n"
"        deta -= ddH*tdH;\n"
"        deta -= dsigma1*teta1+dsigma2*teta2;\n"
"        dchi = gpu_dot3(u,fourw);\n"
"        dh12 = rhat[i]+gpu_dot3(u,spr);\n"
"        dUa = pbsu*(eta*dchi+deta*chi)-dh12*dspu;\n"
"        dUr = pbsr*(eta*dchi+deta*chi)-dh12*dspr;\n"
"        numtyp force=dUr*Ur+dUa*Ua;\n"
"        if (i==0) {\n"
"          f.x+=force;\n"
"          if (vflag>0)\n"
"            virial[0]+=-r[0]*force;\n"
"        } else if (i==1) {\n"
"          f.y+=force;\n"
"          if (vflag>0) {\n"
"            virial[1]+=-r[1]*force;\n"
"            virial[3]+=-r[0]*force;\n"
"          }\n"
"        } else {\n"
"          f.z+=force;\n"
"          if (vflag>0) {\n"
"            virial[2]+=-r[2]*force;\n"
"            virial[4]+=-r[0]*force;\n"
"            virial[5]+=-r[1]*force;\n"
"          }\n"
"        }\n"
"      }\n"
"      \n"
"      sigma1=ucl_recip(sigma1);\n"
"      numtyp fwae[3], p[3];\n"
"      gpu_row_times3(fourw,aTe1,fwae);\n"
"      {\n"
"        gpu_times_column3(lA1_0,rhat,p);\n"
"        dsigma1 = gpu_dot3(p,vsigma1);\n"
"        dH12[0] = lAsa1_0[0]*sigma1+dsigma1*gsigma1[0];\n"
"        dH12[1] = lAsa1_0[1]*sigma1+dsigma1*gsigma1[1];\n"
"        dH12[2] = lAsa1_0[2]*sigma1+dsigma1*gsigma1[2];\n"
"        dH12[3] = lAsa1_0[3]*sigma1+dsigma1*gsigma1[3];\n"
"        dH12[4] = lAsa1_0[4]*sigma1+dsigma1*gsigma1[4];\n"
"        dH12[5] = lAsa1_0[5]*sigma1+dsigma1*gsigma1[5];\n"
"        dH12[6] = lAsa1_0[6]*sigma1+dsigma1*gsigma1[6];\n"
"        dH12[7] = lAsa1_0[7]*sigma1+dsigma1*gsigma1[7];\n"
"        dH12[8] = lAsa1_0[8]*sigma1+dsigma1*gsigma1[8];\n"
"        ddH = det_prime(H12,dH12);\n"
"        deta = tsig1sig2*dsigma1-tdH*ddH;\n"
"        deta -= teta1*dsigma1;\n"
"        numtyp tempv[3];\n"
"        gpu_times_column3(lA1_0,w,tempv);\n"
"        dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times_column3(lAtwo1_0,spr,tempv);\n"
"        dh12 = -gpu_dot3(s,tempv);\n"
"        dUa = pbsu*(eta*dchi + deta*chi)-dh12*dspu;\n"
"        dUr = pbsr*(eta*dchi + deta*chi)-dh12*dspr;\n"
"        tor.x -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"      {\n"
"        gpu_times_column3(lA1_1,rhat,p);\n"
"        dsigma1 = gpu_dot3(p,vsigma1);\n"
"        dH12[0] = lAsa1_1[0]*sigma1+dsigma1*gsigma1[0];\n"
"        dH12[1] = lAsa1_1[1]*sigma1+dsigma1*gsigma1[1];\n"
"        dH12[2] = lAsa1_1[2]*sigma1+dsigma1*gsigma1[2];\n"
"        dH12[3] = lAsa1_1[3]*sigma1+dsigma1*gsigma1[3];\n"
"        dH12[4] = lAsa1_1[4]*sigma1+dsigma1*gsigma1[4];\n"
"        dH12[5] = lAsa1_1[5]*sigma1+dsigma1*gsigma1[5];\n"
"        dH12[6] = lAsa1_1[6]*sigma1+dsigma1*gsigma1[6];\n"
"        dH12[7] = lAsa1_1[7]*sigma1+dsigma1*gsigma1[7];\n"
"        dH12[8] = lAsa1_1[8]*sigma1+dsigma1*gsigma1[8];\n"
"        ddH = det_prime(H12,dH12);\n"
"        deta = tsig1sig2*dsigma1-tdH*ddH;\n"
"        deta -= teta1*dsigma1;\n"
"        numtyp tempv[3];\n"
"        gpu_times_column3(lA1_1,w,tempv);\n"
"        dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times_column3(lAtwo1_1,spr,tempv);\n"
"        dh12 = -gpu_dot3(s,tempv);\n"
"        dUa = pbsu*(eta*dchi + deta*chi)-dh12*dspu;\n"
"        dUr = pbsr*(eta*dchi + deta*chi)-dh12*dspr;\n"
"        tor.y -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"      {\n"
"        gpu_times_column3(lA1_2,rhat,p);\n"
"        dsigma1 = gpu_dot3(p,vsigma1);\n"
"        dH12[0] = lAsa1_2[0]*sigma1+dsigma1*gsigma1[0];\n"
"        dH12[1] = lAsa1_2[1]*sigma1+dsigma1*gsigma1[1];\n"
"        dH12[2] = lAsa1_2[2]*sigma1+dsigma1*gsigma1[2];\n"
"        dH12[3] = lAsa1_2[3]*sigma1+dsigma1*gsigma1[3];\n"
"        dH12[4] = lAsa1_2[4]*sigma1+dsigma1*gsigma1[4];\n"
"        dH12[5] = lAsa1_2[5]*sigma1+dsigma1*gsigma1[5];\n"
"        dH12[6] = lAsa1_2[6]*sigma1+dsigma1*gsigma1[6];\n"
"        dH12[7] = lAsa1_2[7]*sigma1+dsigma1*gsigma1[7];\n"
"        dH12[8] = lAsa1_2[8]*sigma1+dsigma1*gsigma1[8];\n"
"        ddH = det_prime(H12,dH12);\n"
"        deta = tsig1sig2*dsigma1-tdH*ddH;\n"
"        deta -= teta1*dsigma1;\n"
"        numtyp tempv[3];\n"
"        gpu_times_column3(lA1_2,w,tempv);\n"
"        dchi = -gpu_dot3(fwae,tempv);\n"
"        gpu_times_column3(lAtwo1_2,spr,tempv);\n"
"        dh12 = -gpu_dot3(s,tempv);\n"
"        dUa = pbsu*(eta*dchi + deta*chi)-dh12*dspu;\n"
"        dUr = pbsr*(eta*dchi + deta*chi)-dh12*dspr;\n"
"        tor.z -= (dUa*Ua+dUr*Ur);\n"
"      }\n"
"    } \n"
"    store_answers_t(f,tor,energy,virial,ii,astride,tid,t_per_atom,offset,eflag,\n"
"                    vflag,ans,engv);\n"
"  } \n"
"}\n"
;
