const char * sw = 

"#define _texture(name, type)  texture<type> name\n"
"#define _texture_2d(name, type) texture<type,1> name\n"
"#ifdef USE_HIP\n"
"  #include <hip/hip_runtime.h>\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define mul24(x, y) __mul24(x, y)\n"
"    #undef _texture\n"
"    #undef _texture_2d\n"
"    #define _texture(name, type)  __device__ type* name\n"
"    #define _texture_2d(name, type)  __device__ type* name\n"
"  #endif\n"
"  #define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"  #define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"  #define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"  #define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"  #define THREAD_ID_X threadIdx.x\n"
"  #define THREAD_ID_Y threadIdx.y\n"
"  #define BLOCK_ID_X blockIdx.x\n"
"  #define BLOCK_ID_Y blockIdx.y\n"
"  #define BLOCK_SIZE_X blockDim.x\n"
"  #define BLOCK_SIZE_Y blockDim.y\n"
"  #define __kernel extern \"C\" __global__\n"
"  #ifdef __local\n"
"    #undef __local\n"
"  #endif\n"
"  #define __local __shared__\n"
"  #define __global\n"
"  #define restrict __restrict__\n"
"  #define atom_add atomicAdd\n"
"  #define ucl_inline static __inline__ __device__\n"
"  #define THREADS_PER_ATOM 4\n"
"  #define THREADS_PER_CHARGE 8\n"
"  #define BLOCK_NBOR_BUILD 128\n"
"  #define BLOCK_PAIR 256\n"
"  #define BLOCK_BIO_PAIR 256\n"
"  #define BLOCK_ELLIPSE 128\n"
"  #define MAX_SHARED_TYPES 11\n"
"  #ifdef _SINGLE_SINGLE\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      return __shfl_xor(var, laneMask, width);\n"
"  #else\n"
"      return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"  #endif\n"
"    }\n"
"  #else\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"      int2 tmp;\n"
"      tmp.x = __double2hiint(var);\n"
"      tmp.y = __double2loint(var);\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  #else\n"
"      tmp.x = __shfl_xor_sync(0xffffffff, tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor_sync(0xffffffff, tmp.y,laneMask,width);\n"
"  #endif\n"
"      return __hiloint2double(tmp.x,tmp.y);\n"
"    }\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define ARCH 600\n"
"    #define WARP_SIZE 64\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #define ARCH __CUDA_ARCH__\n"
"    #define WARP_SIZE 32\n"
"  #endif\n"
"  #define fast_mul(X,Y) (X)*(Y)\n"
"  #define MEM_THREADS WARP_SIZE\n"
"  #define PPPM_BLOCK_1D 64\n"
"  #define BLOCK_CELL_2D 8\n"
"  #define BLOCK_CELL_ID 128\n"
"  #define MAX_BIO_SHARED_TYPES 128\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) {                        \\\n"
"        int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"        int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"        ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"        ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"        ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"        ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"      }\n"
"      #define fetch(ans,i,q_tex) {                           \\\n"
"        int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"        ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"      }\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"      #define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"    #endif\n"
"  #else\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((double4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((double *)  q_tex) + i))\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((float4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((float *)  q_tex) + i))\n"
"    #endif\n"
"  #endif\n"
"  #ifdef _DOUBLE_DOUBLE\n"
"    #define ucl_exp exp\n"
"    #define ucl_powr pow\n"
"    #define ucl_atan atan\n"
"    #define ucl_cbrt cbrt\n"
"    #define ucl_ceil ceil\n"
"    #define ucl_abs fabs\n"
"    #define ucl_rsqrt rsqrt\n"
"    #define ucl_sqrt sqrt\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"  #else\n"
"    #define ucl_atan atanf\n"
"    #define ucl_cbrt cbrtf\n"
"    #define ucl_ceil ceilf\n"
"    #define ucl_abs fabsf\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"    #define ucl_rsqrt rsqrtf\n"
"    #define ucl_sqrt sqrtf\n"
"    #ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"      #define ucl_exp expf\n"
"      #define ucl_powr powf\n"
"    #else\n"
"      #define ucl_exp __expf\n"
"      #define ucl_powr __powf\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"    \n"
"#ifdef NV_KERNEL\n"
"#define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"#define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"#define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"#define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"#define THREAD_ID_X threadIdx.x\n"
"#define THREAD_ID_Y threadIdx.y\n"
"#define BLOCK_ID_X blockIdx.x\n"
"#define BLOCK_ID_Y blockIdx.y\n"
"#define BLOCK_SIZE_X blockDim.x\n"
"#define BLOCK_SIZE_Y blockDim.y\n"
"#define __kernel extern \"C\" __global__\n"
"#define __local __shared__\n"
"#define __global\n"
"#define restrict __restrict__\n"
"#define atom_add atomicAdd\n"
"#define ucl_inline static __inline__ __device__\n"
"#ifdef __CUDA_ARCH__\n"
"#define ARCH __CUDA_ARCH__\n"
"#else\n"
"#define ARCH 100\n"
"#endif\n"
"#if (ARCH < 200)\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 16\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_PAIR 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#if (ARCH < 300)\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 256\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#if (__CUDACC_VER_MAJOR__ < 9)\n"
"#ifdef _SINGLE_SINGLE\n"
"#define shfl_xor __shfl_xor\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#else\n"
"#ifdef _SINGLE_SINGLE\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"}\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor_sync(0xffffffff,tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor_sync(0xffffffff,tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define fetch4(ans,i,pos_tex) {                        \\\n"
"  int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"  int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"  ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"  ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"  ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"  ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"}\n"
"#define fetch(ans,i,q_tex) {                           \\\n"
"  int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"  ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"}\n"
"#else\n"
"#define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"#define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"#endif\n"
"#if (__CUDA_ARCH__ < 200)\n"
"#define fast_mul __mul24\n"
"#define MEM_THREADS 16\n"
"#else\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define MEM_THREADS 32\n"
"#endif\n"
"#ifdef CUDA_PRE_THREE\n"
"struct __builtin_align__(16) _double4\n"
"{\n"
"  double x, y, z, w;\n"
"};\n"
"typedef struct _double4 double4;\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define ucl_exp exp\n"
"#define ucl_powr pow\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_atan atanf\n"
"#define ucl_cbrt cbrtf\n"
"#define ucl_ceil ceilf\n"
"#define ucl_abs fabsf\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#define ucl_rsqrt rsqrtf\n"
"#define ucl_sqrt sqrtf\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp expf\n"
"#define ucl_powr powf\n"
"#else\n"
"#define ucl_exp __expf\n"
"#define ucl_powr __powf\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef NV_GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define fast_mul mul24\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef FERMI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef KEPLER_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 256\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifndef NO_OCL_PTX\n"
"#define ARCH 300\n"
"#ifdef _SINGLE_SINGLE\n"
"inline float shfl_xor(float var, int laneMask, int width) {\n"
"  float ret;\n"
"  int c;\n"
"  c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=f\"(ret) : \"f\"(var), \"r\"(laneMask), \"r\"(c));\n"
"  return ret;\n"
"}\n"
"#else\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  int x,y,x2,y2;\n"
"  double ans;\n"
"  asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(x2) : \"r\"(x), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(y2) : \"r\"(y), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"  return ans;\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef CYPRESS_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 64\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef INTEL_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 1\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 4\n"
"#define BLOCK_BIO_PAIR 2\n"
"#define BLOCK_ELLIPSE 2\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 1\n"
"#define BLOCK_CELL_ID 2\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef PHI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 16\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 16\n"
"#define BLOCK_BIO_PAIR 16\n"
"#define BLOCK_ELLIPSE 16\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 4\n"
"#define BLOCK_CELL_ID 16\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef USE_OPENCL\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#ifndef fast_mul\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#endif\n"
"#ifndef ARCH\n"
"#define ARCH 0\n"
"#endif\n"
"#ifndef DRIVER\n"
"#define DRIVER 0\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define NO_HARDWARE_TRANSCENDENTALS\n"
"#endif\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#endif\n"
"#endif\n"
"#ifndef PPPM_MAX_SPLINE\n"
"#define PPPM_MAX_SPLINE 8\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#ifndef BLOCK_ELLIPSE\n"
"#define BLOCK_ELLIPSE BLOCK_PAIR\n"
"#endif\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    red_acc[4][tid]=e_coul;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<5; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    e_coul=red_acc[4][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#else\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"      e_coul += shfl_xor(e_coul, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_aux_fun1.h\"\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex,float4);\n"
"_texture( sw1_tex,float4);\n"
"_texture( sw2_tex,float4);\n"
"_texture( sw3_tex,float4);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"_texture( sw1_tex,int4);\n"
"_texture( sw2_tex,int4);\n"
"_texture( sw3_tex,int4);\n"
"#endif\n"
"#else\n"
"#define pos_tex x_\n"
"#define sw1_tex sw1\n"
"#define sw2_tex sw2\n"
"#define sw3_tex sw3\n"
"#endif\n"
"#define THIRD (numtyp)0.66666666666666666667\n"
"#if (ARCH < 300)\n"
"#define store_answers_p(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_ELLIPSE];                               \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]+=energy*(acctyp)0.5;                                         \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]+=virial[i]*(acctyp)0.5;                                    \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#else\n"
"#define store_answers_p(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]+=energy*(acctyp)0.5;                                         \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]+=virial[i]*(acctyp)0.5;                                    \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#endif\n"
"__kernel void k_sw_short_nbor(const __global numtyp4 *restrict x_,\n"
"                           const __global numtyp4 *restrict sw3,\n"
"                           const __global int *restrict map,\n"
"                           const __global int *restrict elem2param,\n"
"                           const int nelements,\n"
"                           const __global int * dev_nbor,\n"
"                           const __global int * dev_packed,\n"
"                           __global int * dev_short_nbor,\n"
"                           const int inum, const int nbor_pitch, const int t_per_atom) {\n"
"  __local int n_stride;\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    int ncount = 0;\n"
"    int m = nbor;\n"
"    dev_short_nbor[m] = 0;\n"
"    int nbor_short = nbor+n_stride;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      int nj = j;\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      if (rsq<sw3[ijparam].y) { \n"
"        dev_short_nbor[nbor_short] = nj;\n"
"        nbor_short += n_stride;\n"
"        ncount++;\n"
"      }\n"
"    } \n"
"    \n"
"    dev_short_nbor[m] = ncount;\n"
"  } \n"
"}\n"
"__kernel void k_sw(const __global numtyp4 *restrict x_,\n"
"                   const __global numtyp4 *restrict sw1,\n"
"                   const __global numtyp4 *restrict sw2,\n"
"                   const __global numtyp4 *restrict sw3,\n"
"                   const __global int *restrict map,\n"
"                   const __global int *restrict elem2param,\n"
"                   const int nelements,\n"
"                   const __global int * dev_nbor,\n"
"                   const __global int * dev_packed,\n"
"                   const __global int * dev_short_nbor,\n"
"                   __global acctyp4 *restrict ans,\n"
"                   __global acctyp *restrict engv,\n"
"                   const int eflag, const int vflag, const int inum,\n"
"                   const int nbor_pitch, const int t_per_atom) {\n"
"  __local int n_stride;\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end, i, numj;\n"
"    const __global int* nbor_mem = dev_packed;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor];\n"
"      nbor += n_stride;\n"
"      nbor_end = nbor+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=nbor_mem[nbor];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      if (rsq<sw3[ijparam].y) { \n"
"        numtyp4 sw1_ijparam; fetch4(sw1_ijparam,ijparam,sw1_tex);\n"
"        numtyp sw_epsilon=sw1_ijparam.x;\n"
"        numtyp sw_sigma=sw1_ijparam.y;\n"
"        numtyp4 sw2_ijparam; fetch4(sw2_ijparam,ijparam,sw2_tex);\n"
"        numtyp sw_biga=sw2_ijparam.x;\n"
"        numtyp sw_bigb=sw2_ijparam.y;\n"
"        numtyp sw_powerp=sw2_ijparam.z;\n"
"        numtyp sw_powerq=sw2_ijparam.w;\n"
"        numtyp4 sw3_ijparam; fetch4(sw3_ijparam,ijparam,sw3_tex);\n"
"        numtyp sw_cut=sw3_ijparam.x;\n"
"        numtyp pre_sw_c1=sw_biga*sw_epsilon*sw_powerp*sw_bigb*\n"
"            pow(sw_sigma,sw_powerp);\n"
"        numtyp pre_sw_c2=sw_biga*sw_epsilon*sw_powerq*\n"
"            pow(sw_sigma,sw_powerq);\n"
"        numtyp pre_sw_c3=sw_biga*sw_epsilon*sw_bigb*\n"
"            pow(sw_sigma,sw_powerp+(numtyp)1.0);\n"
"        numtyp pre_sw_c4=sw_biga*sw_epsilon*\n"
"            pow(sw_sigma,sw_powerq+(numtyp)1.0);\n"
"        numtyp pre_sw_c5=sw_biga*sw_epsilon*sw_bigb*\n"
"            pow(sw_sigma,sw_powerp);\n"
"        numtyp pre_sw_c6=sw_biga*sw_epsilon*\n"
"            pow(sw_sigma,sw_powerq);\n"
"        numtyp r=ucl_sqrt(rsq);\n"
"        numtyp rp=ucl_powr(r,-sw_powerp);\n"
"        numtyp rq=ucl_powr(r,-sw_powerq);\n"
"        numtyp rainv=ucl_recip(r-sw_cut);\n"
"        numtyp expsrainv=ucl_exp(sw_sigma*rainv);\n"
"        rainv*=rainv*r;\n"
"        numtyp force = (pre_sw_c1*rp-pre_sw_c2*rq +\n"
"                       (pre_sw_c3*rp-pre_sw_c4*rq) * rainv)*\n"
"                       expsrainv*ucl_recip(rsq);\n"
"        f.x+=delx*force;\n"
"        f.y+=dely*force;\n"
"        f.z+=delz*force;\n"
"        if (eflag>0)\n"
"          energy+=(pre_sw_c5*rp - pre_sw_c6*rq) * expsrainv;\n"
"        if (vflag>0) {\n"
"          virial[0] += delx*delx*force;\n"
"          virial[1] += dely*dely*force;\n"
"          virial[2] += delz*delz*force;\n"
"          virial[3] += delx*dely*force;\n"
"          virial[4] += delx*delz*force;\n"
"          virial[5] += dely*delz*force;\n"
"        }\n"
"      }\n"
"    } \n"
"    store_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                  ans,engv);\n"
"  } \n"
"}\n"
"#define threebody(delr1x,delr1y,delr1z,delr2x,delr2y,delr2z, eflag, energy)  \\\n"
"{                                                                            \\\n"
"  numtyp r1 = ucl_sqrt(rsq1);                                                \\\n"
"  numtyp rinvsq1 = ucl_recip(rsq1);                                          \\\n"
"  numtyp rainv1 = ucl_recip(r1 - sw_cut_ij);                                 \\\n"
"  numtyp gsrainv1 = sw_sigma_gamma_ij * rainv1;                              \\\n"
"  numtyp gsrainvsq1 = gsrainv1*rainv1/r1;                                    \\\n"
"  numtyp expgsrainv1 = ucl_exp(gsrainv1);                                    \\\n"
"                                                                             \\\n"
"  numtyp r2 = ucl_sqrt(rsq2);                                                \\\n"
"  numtyp rinvsq2 = ucl_recip(rsq2);                                          \\\n"
"  numtyp rainv2 = ucl_recip(r2 - sw_cut_ik);                                 \\\n"
"  numtyp gsrainv2 = sw_sigma_gamma_ik * rainv2;                              \\\n"
"  numtyp gsrainvsq2 = gsrainv2*rainv2/r2;                                    \\\n"
"  numtyp expgsrainv2 = ucl_exp(gsrainv2);                                    \\\n"
"                                                                             \\\n"
"  numtyp rinv12 = ucl_recip(r1*r2);                                          \\\n"
"  numtyp cs = (delr1x*delr2x + delr1y*delr2y + delr1z*delr2z) * rinv12;      \\\n"
"  numtyp delcs = cs - sw_costheta_ijk;                                       \\\n"
"  numtyp delcssq = delcs*delcs;                                              \\\n"
"                                                                             \\\n"
"  numtyp facexp = expgsrainv1*expgsrainv2;                                   \\\n"
"                                                                             \\\n"
"  numtyp facrad = sw_lambda_epsilon_ijk * facexp*delcssq;                    \\\n"
"  numtyp frad1 = facrad*gsrainvsq1;                                          \\\n"
"  numtyp frad2 = facrad*gsrainvsq2;                                          \\\n"
"  numtyp facang = sw_lambda_epsilon2_ijk * facexp*delcs;                     \\\n"
"  numtyp facang12 = rinv12*facang;                                           \\\n"
"  numtyp csfacang = cs*facang;                                               \\\n"
"  numtyp csfac1 = rinvsq1*csfacang;                                          \\\n"
"                                                                             \\\n"
"  fjx = delr1x*(frad1+csfac1)-delr2x*facang12;                               \\\n"
"  fjy = delr1y*(frad1+csfac1)-delr2y*facang12;                               \\\n"
"  fjz = delr1z*(frad1+csfac1)-delr2z*facang12;                               \\\n"
"                                                                             \\\n"
"  numtyp csfac2 = rinvsq2*csfacang;                                          \\\n"
"                                                                             \\\n"
"  fkx = delr2x*(frad2+csfac2)-delr1x*facang12;                               \\\n"
"  fky = delr2y*(frad2+csfac2)-delr1y*facang12;                               \\\n"
"  fkz = delr2z*(frad2+csfac2)-delr1z*facang12;                               \\\n"
"                                                                             \\\n"
"  if (eflag>0)                                                               \\\n"
"    energy+=facrad;                                                          \\\n"
"  if (vflag>0) {                                                             \\\n"
"    virial[0] += delr1x*fjx + delr2x*fkx;                                    \\\n"
"    virial[1] += delr1y*fjy + delr2y*fky;                                    \\\n"
"    virial[2] += delr1z*fjz + delr2z*fkz;                                    \\\n"
"    virial[3] += delr1x*fjy + delr2x*fky;                                    \\\n"
"    virial[4] += delr1x*fjz + delr2x*fkz;                                    \\\n"
"    virial[5] += delr1y*fjz + delr2y*fkz;                                    \\\n"
"  }                                                                          \\\n"
"}\n"
"#define threebody_half(delr1x, delr1y, delr1z, delr2x, delr2y, delr2z)       \\\n"
"{                                                                            \\\n"
"  numtyp r1 = ucl_sqrt(rsq1);                                                \\\n"
"  numtyp rinvsq1 = ucl_recip(rsq1);                                          \\\n"
"  numtyp rainv1 = ucl_recip(r1 - sw_cut_ij);                                 \\\n"
"  numtyp gsrainv1 = sw_sigma_gamma_ij * rainv1;                              \\\n"
"  numtyp gsrainvsq1 = gsrainv1*rainv1/r1;                                    \\\n"
"  numtyp expgsrainv1 = ucl_exp(gsrainv1);                                    \\\n"
"                                                                             \\\n"
"  numtyp r2 = ucl_sqrt(rsq2);                                                \\\n"
"  numtyp rainv2 = ucl_recip(r2 - sw_cut_ik);                                 \\\n"
"  numtyp gsrainv2 = sw_sigma_gamma_ik * rainv2;                              \\\n"
"  numtyp expgsrainv2 = ucl_exp(gsrainv2);                                    \\\n"
"                                                                             \\\n"
"  numtyp rinv12 = ucl_recip(r1*r2);                                          \\\n"
"  numtyp cs = (delr1x*delr2x + delr1y*delr2y + delr1z*delr2z) * rinv12;      \\\n"
"  numtyp delcs = cs - sw_costheta_ijk;                                       \\\n"
"  numtyp delcssq = delcs*delcs;                                              \\\n"
"                                                                             \\\n"
"  numtyp facexp = expgsrainv1*expgsrainv2;                                   \\\n"
"                                                                             \\\n"
"  numtyp facrad = sw_lambda_epsilon_ijk * facexp*delcssq;                    \\\n"
"  numtyp frad1 = facrad*gsrainvsq1;                                          \\\n"
"  numtyp facang = sw_lambda_epsilon2_ijk * facexp*delcs;                     \\\n"
"  numtyp facang12 = rinv12*facang;                                           \\\n"
"  numtyp csfacang = cs*facang;                                               \\\n"
"  numtyp csfac1 = rinvsq1*csfacang;                                          \\\n"
"                                                                             \\\n"
"  fjx = delr1x*(frad1+csfac1)-delr2x*facang12;                               \\\n"
"  fjy = delr1y*(frad1+csfac1)-delr2y*facang12;                               \\\n"
"  fjz = delr1z*(frad1+csfac1)-delr2z*facang12;                               \\\n"
"}\n"
"__kernel void k_sw_three_center(const __global numtyp4 *restrict x_,\n"
"                                const __global numtyp4 *restrict sw1,\n"
"                                const __global numtyp4 *restrict sw2,\n"
"                                const __global numtyp4 *restrict sw3,\n"
"                                const __global int *restrict map,\n"
"                                const __global int *restrict elem2param,\n"
"                                const int nelements,\n"
"                                const __global int * dev_nbor,\n"
"                                const __global int * dev_packed,\n"
"                                const __global int * dev_short_nbor,\n"
"                                __global acctyp4 *restrict ans,\n"
"                                __global acctyp *restrict engv,\n"
"                                const int eflag, const int vflag,\n"
"                                const int inum,  const int nbor_pitch,\n"
"                                const int t_per_atom, const int evatom) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp sw_sigma_gamma_ij, sw_cut_ij, sw_sigma_gamma_ik, sw_cut_ik;\n"
"  numtyp sw_costheta_ijk, sw_lambda_epsilon_ijk, sw_lambda_epsilon2_ijk;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end;\n"
"    const __global int* nbor_mem = dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    int nborj_start = nbor_j;\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      \n"
"      numtyp delr1x = jx.x-ix.x;\n"
"      numtyp delr1y = jx.y-ix.y;\n"
"      numtyp delr1z = jx.z-ix.z;\n"
"      numtyp rsq1 = delr1x*delr1x+delr1y*delr1y+delr1z*delr1z;\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      numtyp4 sw3_ijparam; fetch4(sw3_ijparam,ijparam,sw3_tex);\n"
"      if (rsq1 > sw3_ijparam.y) continue;\n"
"      numtyp4 sw1_ijparam; fetch4(sw1_ijparam,ijparam,sw1_tex);\n"
"      sw_sigma_gamma_ij=sw1_ijparam.y*sw1_ijparam.w; \n"
"      sw_cut_ij=sw3_ijparam.x;\n"
"      int nbor_k,k_end;\n"
"      if (dev_packed==dev_nbor) {\n"
"        nbor_k=nborj_start-offset_j+offset_k;\n"
"        int numk = dev_short_nbor[nbor_k-n_stride];\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      } else {\n"
"        nbor_k = nbor_j-offset_j+offset_k;\n"
"        if (nbor_k<=nbor_j) nbor_k += n_stride;\n"
"        k_end = nbor_end;\n"
"      }\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (dev_packed==dev_nbor && k <= j) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int ikparam=elem2param[itype*nelements*nelements+ktype*nelements+ktype];\n"
"        numtyp4 sw3_ikparam; fetch4(sw3_ikparam,ikparam,sw3_tex);\n"
"        numtyp delr2x = kx.x-ix.x;\n"
"        numtyp delr2y = kx.y-ix.y;\n"
"        numtyp delr2z = kx.z-ix.z;\n"
"        numtyp rsq2 = delr2x*delr2x + delr2y*delr2y + delr2z*delr2z;\n"
"        if (rsq2 < sw3_ikparam.y) {   \n"
"          numtyp4 sw1_ikparam; fetch4(sw1_ikparam,ikparam,sw1_tex);\n"
"          sw_sigma_gamma_ik=sw1_ikparam.y*sw1_ikparam.w; \n"
"          sw_cut_ik=sw3_ikparam.x;\n"
"          int ijkparam=elem2param[itype*nelements*nelements+jtype*nelements+ktype];\n"
"          numtyp4 sw1_ijkparam; fetch4(sw1_ijkparam,ijkparam,sw1_tex);\n"
"          sw_lambda_epsilon_ijk=sw1_ijkparam.x*sw1_ijkparam.z; \n"
"          sw_lambda_epsilon2_ijk=(numtyp)2.0*sw_lambda_epsilon_ijk;\n"
"          numtyp4 sw3_ijkparam; fetch4(sw3_ijkparam,ijkparam,sw3_tex);\n"
"          sw_costheta_ijk=sw3_ijkparam.z;\n"
"          numtyp fjx, fjy, fjz, fkx, fky, fkz;\n"
"          threebody(delr1x,delr1y,delr1z,delr2x,delr2y,delr2z,eflag,energy);\n"
"          f.x -= fjx + fkx;\n"
"          f.y -= fjy + fky;\n"
"          f.z -= fjz + fkz;\n"
"        }\n"
"      }\n"
"    } \n"
"    numtyp pre;\n"
"    if (evatom==1)\n"
"      pre=THIRD;\n"
"    else\n"
"      pre=(numtyp)2.0;\n"
"    energy*=pre;\n"
"    for (int i=0; i<6; i++)\n"
"      virial[i]*=pre;\n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                    eflag,vflag,ans,engv);\n"
"  } \n"
"}\n"
"__kernel void k_sw_three_end(const __global numtyp4 *restrict x_,\n"
"                             const __global numtyp4 *restrict sw1,\n"
"                             const __global numtyp4 *restrict sw2,\n"
"                             const __global numtyp4 *restrict sw3,\n"
"                             const __global int *restrict map,\n"
"                             const __global int *restrict elem2param,\n"
"                             const int nelements,\n"
"                             const __global int * dev_nbor,\n"
"                             const __global int * dev_packed,\n"
"                             const __global int * dev_ilist,\n"
"                             const __global int * dev_short_nbor,\n"
"                             __global acctyp4 *restrict ans,\n"
"                             __global acctyp *restrict engv,\n"
"                             const int eflag, const int vflag,\n"
"                             const int inum,  const int nbor_pitch,\n"
"                             const int t_per_atom, const int gpu_nbor) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp sw_sigma_gamma_ij, sw_cut_ij, sw_sigma_gamma_ik, sw_cut_ik;\n"
"  numtyp sw_costheta_ijk, sw_lambda_epsilon_ijk, sw_lambda_epsilon2_ijk;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end, k_end;\n"
"    const __global int* nbor_mem = dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      \n"
"      numtyp delr1x = ix.x-jx.x;\n"
"      numtyp delr1y = ix.y-jx.y;\n"
"      numtyp delr1z = ix.z-jx.z;\n"
"      numtyp rsq1 = delr1x*delr1x+delr1y*delr1y+delr1z*delr1z;\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      numtyp4 sw3_ijparam; fetch4(sw3_ijparam,ijparam,sw3_tex);\n"
"      if (rsq1 > sw3_ijparam.y) continue;\n"
"      numtyp4 sw1_ijparam; fetch4(sw1_ijparam,ijparam,sw1_tex);\n"
"      sw_sigma_gamma_ij=sw1_ijparam.y*sw1_ijparam.w; \n"
"      sw_cut_ij=sw3_ijparam.x;\n"
"      int nbor_k,numk;\n"
"      if (dev_nbor==dev_packed) {\n"
"        if (gpu_nbor) nbor_k=j+nbor_pitch;\n"
"        else nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch+fast_mul(j,t_per_atom-1);\n"
"        k_end=nbor_k+fast_mul(numk/t_per_atom,n_stride)+(numk & (t_per_atom-1));\n"
"        nbor_k+=offset_k;\n"
"      } else {\n"
"        nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch;\n"
"        nbor_k=dev_nbor[nbor_k];\n"
"        k_end=nbor_k+numk;\n"
"        nbor_k+=offset_k;\n"
"      }\n"
"      \n"
"      if (dev_packed==dev_nbor) {\n"
"        numk = dev_short_nbor[nbor_k];\n"
"        nbor_k += n_stride;\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int ikparam=elem2param[jtype*nelements*nelements+ktype*nelements+ktype]; \n"
"        numtyp delr2x = kx.x - jx.x;\n"
"        numtyp delr2y = kx.y - jx.y;\n"
"        numtyp delr2z = kx.z - jx.z;\n"
"        numtyp rsq2 = delr2x*delr2x + delr2y*delr2y + delr2z*delr2z;\n"
"        numtyp4 sw3_ikparam; fetch4(sw3_ikparam,ikparam,sw3_tex);\n"
"        if (rsq2 < sw3_ikparam.y) {\n"
"          numtyp4 sw1_ikparam; fetch4(sw1_ikparam,ikparam,sw1_tex);\n"
"          sw_sigma_gamma_ik=sw1_ikparam.y*sw1_ikparam.w; \n"
"          sw_cut_ik=sw3_ikparam.x;\n"
"          int ijkparam=elem2param[jtype*nelements*nelements+itype*nelements+ktype]; \n"
"          numtyp4 sw1_ijkparam; fetch4(sw1_ijkparam,ijkparam,sw1_tex);\n"
"          sw_lambda_epsilon_ijk=sw1_ijkparam.x*sw1_ijkparam.z; \n"
"          sw_lambda_epsilon2_ijk=(numtyp)2.0*sw_lambda_epsilon_ijk;\n"
"          numtyp4 sw3_ijkparam; fetch4(sw3_ijkparam,ijkparam,sw3_tex);\n"
"          sw_costheta_ijk=sw3_ijkparam.z;\n"
"          numtyp fjx, fjy, fjz;\n"
"          threebody_half(delr1x,delr1y,delr1z,delr2x,delr2y,delr2z);\n"
"          f.x += fjx;\n"
"          f.y += fjy;\n"
"          f.z += fjz;\n"
"        }\n"
"      }\n"
"    } \n"
"    #ifdef THREE_CONCURRENT\n"
"    store_answers(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                  eflag,vflag,ans,engv);\n"
"    #else\n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                    eflag,vflag,ans,engv);\n"
"    #endif\n"
"  } \n"
"}\n"
"__kernel void k_sw_three_end_vatom(const __global numtyp4 *restrict x_,\n"
"                             const __global numtyp4 *restrict sw1,\n"
"                             const __global numtyp4 *restrict sw2,\n"
"                             const __global numtyp4 *restrict sw3,\n"
"                             const __global int *restrict map,\n"
"                             const __global int *restrict elem2param,\n"
"                             const int nelements,\n"
"                             const __global int * dev_nbor,\n"
"                             const __global int * dev_packed,\n"
"                             const __global int * dev_ilist,\n"
"                             const __global int * dev_short_nbor,\n"
"                             __global acctyp4 *restrict ans,\n"
"                             __global acctyp *restrict engv,\n"
"                             const int eflag, const int vflag,\n"
"                             const int inum,  const int nbor_pitch,\n"
"                             const int t_per_atom, const int gpu_nbor) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp sw_sigma_gamma_ij, sw_cut_ij, sw_sigma_gamma_ik, sw_cut_ik;\n"
"  numtyp sw_costheta_ijk, sw_lambda_epsilon_ijk, sw_lambda_epsilon2_ijk;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end, k_end;\n"
"    const __global int* nbor_mem = dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      \n"
"      numtyp delr1x = ix.x-jx.x;\n"
"      numtyp delr1y = ix.y-jx.y;\n"
"      numtyp delr1z = ix.z-jx.z;\n"
"      numtyp rsq1 = delr1x*delr1x+delr1y*delr1y+delr1z*delr1z;\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      numtyp4 sw3_ijparam; fetch4(sw3_ijparam,ijparam,sw3_tex);\n"
"      if (rsq1 > sw3_ijparam.y) continue;\n"
"      numtyp4 sw1_ijparam; fetch4(sw1_ijparam,ijparam,sw1_tex);\n"
"      sw_sigma_gamma_ij=sw1_ijparam.y*sw1_ijparam.w; \n"
"      sw_cut_ij=sw3_ijparam.x;\n"
"      int nbor_k,numk;\n"
"      if (dev_nbor==dev_packed) {\n"
"        if (gpu_nbor) nbor_k=j+nbor_pitch;\n"
"        else nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch+fast_mul(j,t_per_atom-1);\n"
"        k_end=nbor_k+fast_mul(numk/t_per_atom,n_stride)+(numk & (t_per_atom-1));\n"
"        nbor_k+=offset_k;\n"
"      } else {\n"
"        nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch;\n"
"        nbor_k=dev_nbor[nbor_k];\n"
"        k_end=nbor_k+numk;\n"
"        nbor_k+=offset_k;\n"
"      }\n"
"      \n"
"      if (dev_packed==dev_nbor) {\n"
"        numk = dev_short_nbor[nbor_k];\n"
"        nbor_k += n_stride;\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int ikparam=elem2param[jtype*nelements*nelements+ktype*nelements+ktype]; \n"
"        numtyp4 sw3_ikparam; fetch4(sw3_ikparam,ikparam,sw3_tex);\n"
"        numtyp delr2x = kx.x - jx.x;\n"
"        numtyp delr2y = kx.y - jx.y;\n"
"        numtyp delr2z = kx.z - jx.z;\n"
"        numtyp rsq2 = delr2x*delr2x + delr2y*delr2y + delr2z*delr2z;\n"
"        if (rsq2 < sw3_ikparam.y) {\n"
"          numtyp4 sw1_ikparam; fetch4(sw1_ikparam,ikparam,sw1_tex);\n"
"          sw_sigma_gamma_ik=sw1_ikparam.y*sw1_ikparam.w; \n"
"          sw_cut_ik=sw3_ikparam.x;\n"
"          int ijkparam=elem2param[jtype*nelements*nelements+itype*nelements+ktype]; \n"
"          numtyp4 sw1_ijkparam; fetch4(sw1_ijkparam,ijkparam,sw1_tex);\n"
"          sw_lambda_epsilon_ijk=sw1_ijkparam.x*sw1_ijkparam.z; \n"
"          sw_lambda_epsilon2_ijk=(numtyp)2.0*sw_lambda_epsilon_ijk;\n"
"          numtyp4 sw3_ijkparam; fetch4(sw3_ijkparam,ijkparam,sw3_tex);\n"
"          sw_costheta_ijk=sw3_ijkparam.z;\n"
"          numtyp fjx, fjy, fjz, fkx, fky, fkz;\n"
"          threebody(delr1x,delr1y,delr1z,delr2x,delr2y,delr2z,eflag,energy);\n"
"          f.x += fjx;\n"
"          f.y += fjy;\n"
"          f.z += fjz;\n"
"        }\n"
"      }\n"
"    } \n"
"    energy*=THIRD;\n"
"    for (int i=0; i<6; i++)\n"
"      virial[i]*=THIRD;\n"
"    #ifdef THREE_CONCURRENT\n"
"    store_answers(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                  eflag,vflag,ans,engv);\n"
"    #else\n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                    eflag,vflag,ans,engv);\n"
"    #endif\n"
"  } \n"
"}\n"
;
