const char * tersoff_zbl = 

"#define _texture(name, type)  texture<type> name\n"
"#define _texture_2d(name, type) texture<type,1> name\n"
"#ifdef USE_HIP\n"
"  #include <hip/hip_runtime.h>\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define mul24(x, y) __mul24(x, y)\n"
"    #undef _texture\n"
"    #undef _texture_2d\n"
"    #define _texture(name, type)  __device__ type* name\n"
"    #define _texture_2d(name, type)  __device__ type* name\n"
"  #endif\n"
"  #define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"  #define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"  #define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"  #define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"  #define THREAD_ID_X threadIdx.x\n"
"  #define THREAD_ID_Y threadIdx.y\n"
"  #define BLOCK_ID_X blockIdx.x\n"
"  #define BLOCK_ID_Y blockIdx.y\n"
"  #define BLOCK_SIZE_X blockDim.x\n"
"  #define BLOCK_SIZE_Y blockDim.y\n"
"  #define __kernel extern \"C\" __global__\n"
"  #ifdef __local\n"
"    #undef __local\n"
"  #endif\n"
"  #define __local __shared__\n"
"  #define __global\n"
"  #define restrict __restrict__\n"
"  #define atom_add atomicAdd\n"
"  #define ucl_inline static __inline__ __device__\n"
"  #define THREADS_PER_ATOM 4\n"
"  #define THREADS_PER_CHARGE 8\n"
"  #define BLOCK_NBOR_BUILD 128\n"
"  #define BLOCK_PAIR 256\n"
"  #define BLOCK_BIO_PAIR 256\n"
"  #define BLOCK_ELLIPSE 128\n"
"  #define MAX_SHARED_TYPES 11\n"
"  #ifdef _SINGLE_SINGLE\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      return __shfl_xor(var, laneMask, width);\n"
"  #else\n"
"      return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"  #endif\n"
"    }\n"
"  #else\n"
"    ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"      int2 tmp;\n"
"      tmp.x = __double2hiint(var);\n"
"      tmp.y = __double2loint(var);\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"      tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  #else\n"
"      tmp.x = __shfl_xor_sync(0xffffffff, tmp.x,laneMask,width);\n"
"      tmp.y = __shfl_xor_sync(0xffffffff, tmp.y,laneMask,width);\n"
"  #endif\n"
"      return __hiloint2double(tmp.x,tmp.y);\n"
"    }\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_HCC__\n"
"    #define ARCH 600\n"
"    #define WARP_SIZE 64\n"
"  #endif\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #define ARCH __CUDA_ARCH__\n"
"    #define WARP_SIZE 32\n"
"  #endif\n"
"  #define fast_mul(X,Y) (X)*(Y)\n"
"  #define MEM_THREADS WARP_SIZE\n"
"  #define PPPM_BLOCK_1D 64\n"
"  #define BLOCK_CELL_2D 8\n"
"  #define BLOCK_CELL_ID 128\n"
"  #define MAX_BIO_SHARED_TYPES 128\n"
"  #ifdef __HIP_PLATFORM_NVCC__\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) {                        \\\n"
"        int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"        int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"        ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"        ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"        ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"        ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"      }\n"
"      #define fetch(ans,i,q_tex) {                           \\\n"
"        int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"        ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"      }\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"      #define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"    #endif\n"
"  #else\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((double4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((double *)  q_tex) + i))\n"
"    #else\n"
"      #define fetch4(ans,i,pos_tex) (ans=*(((float4*)pos_tex) + i))\n"
"      #define fetch(ans,i,q_tex)    (ans=*(((float *)  q_tex) + i))\n"
"    #endif\n"
"  #endif\n"
"  #ifdef _DOUBLE_DOUBLE\n"
"    #define ucl_exp exp\n"
"    #define ucl_powr pow\n"
"    #define ucl_atan atan\n"
"    #define ucl_cbrt cbrt\n"
"    #define ucl_ceil ceil\n"
"    #define ucl_abs fabs\n"
"    #define ucl_rsqrt rsqrt\n"
"    #define ucl_sqrt sqrt\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"  #else\n"
"    #define ucl_atan atanf\n"
"    #define ucl_cbrt cbrtf\n"
"    #define ucl_ceil ceilf\n"
"    #define ucl_abs fabsf\n"
"    #define ucl_recip(x) ((numtyp)1.0/(x))\n"
"    #define ucl_rsqrt rsqrtf\n"
"    #define ucl_sqrt sqrtf\n"
"    #ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"      #define ucl_exp expf\n"
"      #define ucl_powr powf\n"
"    #else\n"
"      #define ucl_exp __expf\n"
"      #define ucl_powr __powf\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"    \n"
"#ifdef NV_KERNEL\n"
"#define GLOBAL_ID_X threadIdx.x+mul24(blockIdx.x,blockDim.x)\n"
"#define GLOBAL_ID_Y threadIdx.y+mul24(blockIdx.y,blockDim.y)\n"
"#define GLOBAL_SIZE_X mul24(gridDim.x,blockDim.x);\n"
"#define GLOBAL_SIZE_Y mul24(gridDim.y,blockDim.y);\n"
"#define THREAD_ID_X threadIdx.x\n"
"#define THREAD_ID_Y threadIdx.y\n"
"#define BLOCK_ID_X blockIdx.x\n"
"#define BLOCK_ID_Y blockIdx.y\n"
"#define BLOCK_SIZE_X blockDim.x\n"
"#define BLOCK_SIZE_Y blockDim.y\n"
"#define __kernel extern \"C\" __global__\n"
"#define __local __shared__\n"
"#define __global\n"
"#define restrict __restrict__\n"
"#define atom_add atomicAdd\n"
"#define ucl_inline static __inline__ __device__\n"
"#ifdef __CUDA_ARCH__\n"
"#define ARCH __CUDA_ARCH__\n"
"#else\n"
"#define ARCH 100\n"
"#endif\n"
"#if (ARCH < 200)\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 16\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_PAIR 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#if (ARCH < 300)\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#else\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_PAIR 256\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#if (__CUDACC_VER_MAJOR__ < 9)\n"
"#ifdef _SINGLE_SINGLE\n"
"#define shfl_xor __shfl_xor\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor(tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor(tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#else\n"
"#ifdef _SINGLE_SINGLE\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  return __shfl_xor_sync(0xffffffff, var, laneMask, width);\n"
"}\n"
"#else\n"
"ucl_inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int2 tmp;\n"
"  tmp.x = __double2hiint(var);\n"
"  tmp.y = __double2loint(var);\n"
"  tmp.x = __shfl_xor_sync(0xffffffff,tmp.x,laneMask,width);\n"
"  tmp.y = __shfl_xor_sync(0xffffffff,tmp.y,laneMask,width);\n"
"  return __hiloint2double(tmp.x,tmp.y);\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define fetch4(ans,i,pos_tex) {                        \\\n"
"  int4 xy = tex1Dfetch(pos_tex,i*2);                   \\\n"
"  int4 zt = tex1Dfetch(pos_tex,i*2+1);                 \\\n"
"  ans.x=__hiloint2double(xy.y, xy.x);                  \\\n"
"  ans.y=__hiloint2double(xy.w, xy.z);                  \\\n"
"  ans.z=__hiloint2double(zt.y, zt.x);                  \\\n"
"  ans.w=__hiloint2double(zt.w, zt.z);                  \\\n"
"}\n"
"#define fetch(ans,i,q_tex) {                           \\\n"
"  int2 qt = tex1Dfetch(q_tex,i);                       \\\n"
"  ans=__hiloint2double(qt.y, qt.x);                    \\\n"
"}\n"
"#else\n"
"#define fetch4(ans,i,pos_tex) ans=tex1Dfetch(pos_tex, i);\n"
"#define fetch(ans,i,q_tex) ans=tex1Dfetch(q_tex,i);\n"
"#endif\n"
"#if (__CUDA_ARCH__ < 200)\n"
"#define fast_mul __mul24\n"
"#define MEM_THREADS 16\n"
"#else\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define MEM_THREADS 32\n"
"#endif\n"
"#ifdef CUDA_PRE_THREE\n"
"struct __builtin_align__(16) _double4\n"
"{\n"
"  double x, y, z, w;\n"
"};\n"
"typedef struct _double4 double4;\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define ucl_exp exp\n"
"#define ucl_powr pow\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_atan atanf\n"
"#define ucl_cbrt cbrtf\n"
"#define ucl_ceil ceilf\n"
"#define ucl_abs fabsf\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#define ucl_rsqrt rsqrtf\n"
"#define ucl_sqrt sqrtf\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp expf\n"
"#define ucl_powr powf\n"
"#else\n"
"#define ucl_exp __expf\n"
"#define ucl_powr __powf\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef NV_GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define fast_mul mul24\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef FERMI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef KEPLER_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 256\n"
"#define MAX_SHARED_TYPES 11\n"
"#define BLOCK_NBOR_BUILD 128\n"
"#define BLOCK_BIO_PAIR 256\n"
"#define BLOCK_ELLIPSE 128\n"
"#define WARP_SIZE 32\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#ifndef NO_OCL_PTX\n"
"#define ARCH 300\n"
"#ifdef _SINGLE_SINGLE\n"
"inline float shfl_xor(float var, int laneMask, int width) {\n"
"  float ret;\n"
"  int c;\n"
"  c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=f\"(ret) : \"f\"(var), \"r\"(laneMask), \"r\"(c));\n"
"  return ret;\n"
"}\n"
"#else\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"inline double shfl_xor(double var, int laneMask, int width) {\n"
"  int c = ((WARP_SIZE-width) << 8) | 0x1f;\n"
"  int x,y,x2,y2;\n"
"  double ans;\n"
"  asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(x2) : \"r\"(x), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"shfl.bfly.b32 %0, %1, %2, %3;\" : \"=r\"(y2) : \"r\"(y), \"r\"(laneMask), \"r\"(c));\n"
"  asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"  return ans;\n"
"}\n"
"#endif\n"
"#endif\n"
"#endif\n"
"#ifdef CYPRESS_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 32\n"
"#define THREADS_PER_ATOM 4\n"
"#define THREADS_PER_CHARGE 8\n"
"#define BLOCK_PAIR 128\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 64\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef INTEL_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 1\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 4\n"
"#define BLOCK_BIO_PAIR 2\n"
"#define BLOCK_ELLIPSE 2\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 1\n"
"#define BLOCK_CELL_ID 2\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef PHI_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 16\n"
"#define MAX_SHARED_TYPES 0\n"
"#define BLOCK_NBOR_BUILD 16\n"
"#define BLOCK_BIO_PAIR 16\n"
"#define BLOCK_ELLIPSE 16\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 32\n"
"#define BLOCK_CELL_2D 4\n"
"#define BLOCK_CELL_ID 16\n"
"#define MAX_BIO_SHARED_TYPES 0\n"
"#endif\n"
"#ifdef GENERIC_OCL\n"
"#define USE_OPENCL\n"
"#define MEM_THREADS 16\n"
"#define THREADS_PER_ATOM 1\n"
"#define THREADS_PER_CHARGE 1\n"
"#define BLOCK_PAIR 64\n"
"#define MAX_SHARED_TYPES 8\n"
"#define BLOCK_NBOR_BUILD 64\n"
"#define BLOCK_BIO_PAIR 64\n"
"#define WARP_SIZE 1\n"
"#define PPPM_BLOCK_1D 64\n"
"#define BLOCK_CELL_2D 8\n"
"#define BLOCK_CELL_ID 128\n"
"#define MAX_BIO_SHARED_TYPES 128\n"
"#endif\n"
"#ifdef USE_OPENCL\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#ifndef fast_mul\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#endif\n"
"#ifndef ARCH\n"
"#define ARCH 0\n"
"#endif\n"
"#ifndef DRIVER\n"
"#define DRIVER 0\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define NO_HARDWARE_TRANSCENDENTALS\n"
"#endif\n"
"#ifdef NO_HARDWARE_TRANSCENDENTALS\n"
"#define ucl_exp exp\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#else\n"
"#define ucl_exp native_exp\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#endif\n"
"#endif\n"
"#ifndef PPPM_MAX_SPLINE\n"
"#define PPPM_MAX_SPLINE 8\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#ifndef BLOCK_ELLIPSE\n"
"#define BLOCK_ELLIPSE BLOCK_PAIR\n"
"#endif\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    red_acc[4][tid]=e_coul;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<5; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    e_coul=red_acc[4][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#else\n"
"#define store_answers(f, energy, virial, ii, inum, tid, t_per_atom, offset, \\\n"
"                      eflag, vflag, ans, engv)                              \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"        f.x += shfl_xor(f.x, s, t_per_atom);                                \\\n"
"        f.y += shfl_xor(f.y, s, t_per_atom);                                \\\n"
"        f.z += shfl_xor(f.z, s, t_per_atom);                                \\\n"
"        energy += shfl_xor(energy, s, t_per_atom);                          \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"      e_coul += shfl_xor(e_coul, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]=energy*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"      engv[ei]=e_coul*(acctyp)0.5;                                          \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]=virial[i]*(acctyp)0.5;                                     \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    ans[ii]=f;                                                              \\\n"
"  }\n"
"#endif\n"

"#ifndef LAL_TERSOFF_ZBL_EXTRA_H\n"
"#define LAL_TERSOFF_ZBL_EXTRA_H\n"
"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_aux_fun1.h\"\n"
"#else\n"
"#endif\n"
"#define MY_PI (numtyp)3.14159265358979323846\n"
"#define MY_PI2 (numtyp)1.57079632679489661923\n"
"#define MY_PI4 (numtyp)0.78539816339744830962\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp vec3_dot(const numtyp x[3], const numtyp y[3])\n"
"{\n"
"  return (x[0]*y[0] + x[1]*y[1] + x[2]*y[2]);\n"
"}\n"
"ucl_inline void vec3_add(const numtyp x[3], const numtyp y[3], numtyp z[3])\n"
"{\n"
"  z[0] = x[0]+y[0]; z[1] = x[1]+y[1]; z[2] = x[2]+y[2];\n"
"}\n"
"ucl_inline void vec3_scale(const numtyp k, const numtyp x[3], numtyp y[3])\n"
"{\n"
"  y[0] = k*x[0]; y[1] = k*x[1]; y[2] = k*x[2];\n"
"}\n"
"ucl_inline void vec3_scaleadd(const numtyp k, const numtyp x[3],\n"
"                              const numtyp y[3], numtyp z[3])\n"
"{\n"
"  z[0] = k*x[0]+y[0]; z[1] = k*x[1]+y[1]; z[2] = k*x[2]+y[2];\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_gijk(const numtyp costheta,\n"
"                            const numtyp param_c,\n"
"                            const numtyp param_d,\n"
"                            const numtyp param_h,\n"
"                            const numtyp param_gamma)\n"
"{\n"
"  const numtyp ters_c = param_c * param_c;\n"
"  const numtyp ters_d = param_d * param_d;\n"
"  const numtyp hcth = param_h - costheta;\n"
"  return param_gamma*((numtyp)1.0 + ters_c*ucl_recip(ters_d) -\n"
"         ters_c *ucl_recip(ters_d + hcth*hcth));\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_gijk_d(const numtyp costheta,\n"
"                              const numtyp param_c,\n"
"                              const numtyp param_d,\n"
"                              const numtyp param_h,\n"
"                              const numtyp param_gamma)\n"
"{\n"
"  const numtyp ters_c = param_c * param_c;\n"
"  const numtyp ters_d = param_d * param_d;\n"
"  const numtyp hcth = param_h - costheta;\n"
"  const numtyp numerator = (numtyp)-2.0 * ters_c * hcth;\n"
"  const numtyp denominator = ucl_recip(ters_d + hcth*hcth);\n"
"  return param_gamma*numerator*denominator*denominator;\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline void costheta_d(const numtyp rij_hat[3],\n"
"                           const numtyp rij,\n"
"                           const numtyp rik_hat[3],\n"
"                           const numtyp rik,\n"
"                           numtyp *dri,\n"
"                           numtyp *drj,\n"
"                           numtyp *drk)\n"
"{\n"
"  \n"
"  numtyp cos_theta = vec3_dot(rij_hat,rik_hat);\n"
"  vec3_scaleadd(-cos_theta,rij_hat,rik_hat,drj);\n"
"  vec3_scale(ucl_recip(rij),drj,drj);\n"
"  vec3_scaleadd(-cos_theta,rik_hat,rij_hat,drk);\n"
"  vec3_scale(ucl_recip(rik),drk,drk);\n"
"  vec3_add(drj,drk,dri);\n"
"  vec3_scale((numtyp)-1.0,dri,dri);\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_fc(const numtyp r,\n"
"                          const numtyp param_bigr,\n"
"                          const numtyp param_bigd)\n"
"{\n"
"  if (r < param_bigr-param_bigd) return (numtyp)1.0;\n"
"  if (r > param_bigr+param_bigd) return (numtyp)0.0;\n"
"  return (numtyp)0.5*((numtyp)1.0 - sin(MY_PI2*(r - param_bigr)/param_bigd));\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_fc_d(const numtyp r,\n"
"                            const numtyp param_bigr,\n"
"                            const numtyp param_bigd)\n"
"{\n"
"  if (r < param_bigr-param_bigd) return (numtyp)0.0;\n"
"  if (r > param_bigr+param_bigd) return (numtyp)0.0;\n"
"  return -(MY_PI4/param_bigd) * cos(MY_PI2*(r - param_bigr)/param_bigd);\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp F_fermi(const numtyp r, const numtyp param_ZBLcut,\n"
"                          const numtyp param_ZBLexpscale)\n"
"{\n"
"  return ucl_recip((numtyp)1.0+ucl_exp(-param_ZBLexpscale*(r-param_ZBLcut)));\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp F_fermi_d(const numtyp r, const numtyp param_ZBLcut,\n"
"                            const numtyp param_ZBLexpscale)\n"
"{\n"
"  numtyp a = ucl_exp(-param_ZBLexpscale*(r-param_ZBLcut));\n"
"  numtyp b = (numtyp)1.0 + a;\n"
"  return param_ZBLexpscale*a*ucl_recip(b*b);\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_fa(const numtyp r,\n"
"                          const numtyp param_bigb,\n"
"                          const numtyp param_bigr,\n"
"                          const numtyp param_bigd,\n"
"                          const numtyp param_lam2,\n"
"                          const numtyp param_ZBLcut,\n"
"                          const numtyp param_ZBLexpscale)\n"
"{\n"
"  if (r > param_bigr + param_bigd) return (numtyp)0.0;\n"
"  return -param_bigb * ucl_exp(-param_lam2 * r) *\n"
"    ters_fc(r,param_bigr,param_bigd)*F_fermi(r,param_ZBLcut,param_ZBLexpscale);\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_fa_d(const numtyp r,\n"
"                            const numtyp param_bigb,\n"
"                            const numtyp param_bigr,\n"
"                            const numtyp param_bigd,\n"
"                            const numtyp param_lam2,\n"
"                            const numtyp param_ZBLcut,\n"
"                            const numtyp param_ZBLexpscale)\n"
"{\n"
"  if (r > param_bigr + param_bigd) return (numtyp)0.0;\n"
"  numtyp f = F_fermi(r,param_ZBLcut,param_ZBLexpscale);\n"
"  return param_bigb * ucl_exp(-param_lam2 * r) *\n"
"    (param_lam2 * ters_fc(r,param_bigr,param_bigd) * f -\n"
"    ters_fc_d(r,param_bigr,param_bigd) * f -\n"
"    ters_fc(r,param_bigr,param_bigd) * F_fermi_d(r,param_ZBLcut,param_ZBLexpscale));\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_bij(const numtyp zeta,\n"
"                           const numtyp param_beta,\n"
"                           const numtyp param_powern,\n"
"                           const numtyp param_c1,\n"
"                           const numtyp param_c2,\n"
"                           const numtyp param_c3,\n"
"                           const numtyp param_c4)\n"
"{\n"
"  numtyp tmp = param_beta * zeta;\n"
"  if (tmp > param_c1) return ucl_rsqrt(tmp);\n"
"  if (tmp > param_c2)\n"
"    return ((numtyp)1.0 - ucl_powr(tmp,-param_powern) /\n"
"      ((numtyp)2.0*param_powern))*ucl_rsqrt(tmp);\n"
"  if (tmp < param_c4) return (numtyp)1.0;\n"
"  if (tmp < param_c3)\n"
"    return (numtyp)1.0 - ucl_powr(tmp,param_powern)/((numtyp)2.0*param_powern);\n"
"  return ucl_powr((numtyp)1.0 + ucl_powr(tmp,param_powern),\n"
"    (numtyp)-1.0/((numtyp)2.0*param_powern));\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp ters_bij_d(const numtyp zeta,\n"
"                             const numtyp param_beta,\n"
"                             const numtyp param_powern,\n"
"                             const numtyp param_c1,\n"
"                             const numtyp param_c2,\n"
"                             const numtyp param_c3,\n"
"                             const numtyp param_c4)\n"
"{\n"
"  numtyp tmp = param_beta * zeta;\n"
"  if (tmp > param_c1)\n"
"    return param_beta * (numtyp)-0.5*ucl_powr(tmp,(numtyp)-1.5);\n"
"  if (tmp > param_c2)\n"
"    return param_beta * ((numtyp)-0.5*ucl_powr(tmp,(numtyp)-1.5) *\n"
"    \n"
"                \n"
"      ((numtyp)1.0 - ((numtyp)1.0 + (numtyp)1.0 /((numtyp)2.0 * param_powern)) *\n"
"       ucl_powr(tmp,-param_powern)));\n"
"  if (tmp < param_c4) return (numtyp)0.0;\n"
"  if (tmp < param_c3)\n"
"    return (numtyp)-0.5*param_beta * ucl_powr(tmp,param_powern-(numtyp)1.0);\n"
"  numtyp tmp_n = ucl_powr(tmp,param_powern);\n"
"  return (numtyp)-0.5 * ucl_powr((numtyp)1.0+tmp_n, (numtyp) -\n"
"    (numtyp)1.0-((numtyp)1.0 / ((numtyp)2.0 * param_powern)))*tmp_n / zeta;\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline void ters_zetaterm_d(const numtyp prefactor,\n"
"                                const numtyp rij_hat[3],\n"
"                                const numtyp rij,\n"
"                                const numtyp rik_hat[3],\n"
"                                const numtyp rik,\n"
"                                const numtyp param_bigr,\n"
"                                const numtyp param_bigd,\n"
"                                const numtyp param_powermint,\n"
"                                const numtyp param_lam3,\n"
"                                const numtyp param_c,\n"
"                                const numtyp param_d,\n"
"                                const numtyp param_h,\n"
"                                const numtyp param_gamma,\n"
"                                numtyp dri[3],\n"
"                                numtyp drj[3],\n"
"                                numtyp drk[3])\n"
"{\n"
"  numtyp gijk,gijk_d,ex_delr,ex_delr_d,fc,dfc,cos_theta,tmp;\n"
"  numtyp dcosdri[3],dcosdrj[3],dcosdrk[3];\n"
"  fc = ters_fc(rik,param_bigr,param_bigd);\n"
"  dfc = ters_fc_d(rik,param_bigr,param_bigd);\n"
"  numtyp t = param_lam3*(rij-rik);\n"
"  if ((int)param_powermint == 3) tmp = t*t*t;\n"
"  else tmp = t;\n"
"  if (tmp > (numtyp)69.0776) ex_delr = (numtyp)1.e30;\n"
"  else if (tmp < (numtyp)-69.0776) ex_delr = (numtyp)0.0;\n"
"  else ex_delr = ucl_exp(tmp);\n"
"  if ((int)param_powermint == 3)\n"
"    ex_delr_d = (numtyp)3.0*param_lam3*t*t*ex_delr;\n"
"  else ex_delr_d = param_lam3 * ex_delr;\n"
"  cos_theta = vec3_dot(rij_hat,rik_hat);\n"
"  gijk = ters_gijk(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  gijk_d = ters_gijk_d(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  costheta_d(rij_hat,rij,rik_hat,rik,dcosdri,dcosdrj,dcosdrk);\n"
"  \n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(-dfc*gijk*ex_delr,rik_hat,dri);\n"
"  vec3_scaleadd(fc*gijk_d*ex_delr,dcosdri,dri,dri);\n"
"  vec3_scaleadd(fc*gijk*ex_delr_d,rik_hat,dri,dri);\n"
"  vec3_scaleadd(-fc*gijk*ex_delr_d,rij_hat,dri,dri);\n"
"  vec3_scale(prefactor,dri,dri);\n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(fc*gijk_d*ex_delr,dcosdrj,drj);\n"
"  vec3_scaleadd(fc*gijk*ex_delr_d,rij_hat,drj,drj);\n"
"  vec3_scale(prefactor,drj,drj);\n"
"  \n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(dfc*gijk*ex_delr,rik_hat,drk);\n"
"  vec3_scaleadd(fc*gijk_d*ex_delr,dcosdrk,drk,drk);\n"
"  vec3_scaleadd(-fc*gijk*ex_delr_d,rik_hat,drk,drk);\n"
"  vec3_scale(prefactor,drk,drk);\n"
"}\n"
"ucl_inline void ters_zetaterm_d_fi(const numtyp prefactor,\n"
"                                   const numtyp rij_hat[3],\n"
"                                   const numtyp rij,\n"
"                                   const numtyp rik_hat[3],\n"
"                                   const numtyp rik,\n"
"                                   const numtyp param_bigr,\n"
"                                   const numtyp param_bigd,\n"
"                                   const numtyp param_powermint,\n"
"                                   const numtyp param_lam3,\n"
"                                   const numtyp param_c,\n"
"                                   const numtyp param_d,\n"
"                                   const numtyp param_h,\n"
"                                   const numtyp param_gamma,\n"
"                                   numtyp dri[3])\n"
"{\n"
"  numtyp gijk,gijk_d,ex_delr,ex_delr_d,fc,dfc,cos_theta,tmp;\n"
"  numtyp dcosdri[3],dcosdrj[3],dcosdrk[3];\n"
"  fc = ters_fc(rik,param_bigr,param_bigd);\n"
"  dfc = ters_fc_d(rik,param_bigr,param_bigd);\n"
"  numtyp t = param_lam3*(rij-rik);\n"
"  if ((int)param_powermint == 3) tmp = t*t*t;\n"
"  else tmp = t;\n"
"  if (tmp > (numtyp)69.0776) ex_delr = (numtyp)1.e30;\n"
"  else if (tmp < (numtyp)-69.0776) ex_delr = (numtyp)0.0;\n"
"  else ex_delr = ucl_exp(tmp);\n"
"  if ((int)param_powermint == 3)\n"
"    ex_delr_d = (numtyp)3.0*param_lam3*t*t*ex_delr;\n"
"  else ex_delr_d = param_lam3 * ex_delr;\n"
"  cos_theta = vec3_dot(rij_hat,rik_hat);\n"
"  gijk = ters_gijk(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  gijk_d = ters_gijk_d(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  costheta_d(rij_hat,rij,rik_hat,rik,dcosdri,dcosdrj,dcosdrk);\n"
"  \n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(-dfc*gijk*ex_delr,rik_hat,dri);\n"
"  vec3_scaleadd(fc*gijk_d*ex_delr,dcosdri,dri,dri);\n"
"  vec3_scaleadd(fc*gijk*ex_delr_d,rik_hat,dri,dri);\n"
"  vec3_scaleadd(-fc*gijk*ex_delr_d,rij_hat,dri,dri);\n"
"  vec3_scale(prefactor,dri,dri);\n"
"}\n"
"ucl_inline void ters_zetaterm_d_fj(const numtyp prefactor,\n"
"                                   const numtyp rij_hat[3],\n"
"                                   const numtyp rij,\n"
"                                   const numtyp rik_hat[3],\n"
"                                   const numtyp rik,\n"
"                                   const numtyp param_bigr,\n"
"                                   const numtyp param_bigd,\n"
"                                   const numtyp param_powermint,\n"
"                                   const numtyp param_lam3,\n"
"                                   const numtyp param_c,\n"
"                                   const numtyp param_d,\n"
"                                   const numtyp param_h,\n"
"                                   const numtyp param_gamma,\n"
"                                   numtyp drj[3])\n"
"{\n"
"  numtyp gijk,gijk_d,ex_delr,ex_delr_d,fc,cos_theta,tmp;\n"
"  numtyp dcosdri[3],dcosdrj[3],dcosdrk[3];\n"
"  fc = ters_fc(rik,param_bigr,param_bigd);\n"
"  numtyp t = param_lam3*(rij-rik);\n"
"  if ((int)param_powermint == 3) tmp = t*t*t;\n"
"  else tmp = t;\n"
"  if (tmp > (numtyp)69.0776) ex_delr = (numtyp)1.e30;\n"
"  else if (tmp < (numtyp)-69.0776) ex_delr = (numtyp)0.0;\n"
"  else ex_delr = ucl_exp(tmp);\n"
"  if ((int)param_powermint == 3)\n"
"    ex_delr_d = (numtyp)3.0*param_lam3*t*t*ex_delr;\n"
"  else ex_delr_d = param_lam3 * ex_delr;\n"
"  cos_theta = vec3_dot(rij_hat,rik_hat);\n"
"  gijk = ters_gijk(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  gijk_d = ters_gijk_d(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  costheta_d(rij_hat,rij,rik_hat,rik,dcosdri,dcosdrj,dcosdrk);\n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(fc*gijk_d*ex_delr,dcosdrj,drj);\n"
"  vec3_scaleadd(fc*gijk*ex_delr_d,rij_hat,drj,drj);\n"
"  vec3_scale(prefactor,drj,drj);\n"
"}\n"
"ucl_inline void ters_zetaterm_d_fk(const numtyp prefactor,\n"
"                                   const numtyp rij_hat[3],\n"
"                                   const numtyp rij,\n"
"                                   const numtyp rik_hat[3],\n"
"                                   const numtyp rik,\n"
"                                   const numtyp param_bigr,\n"
"                                   const numtyp param_bigd,\n"
"                                   const numtyp param_powermint,\n"
"                                   const numtyp param_lam3,\n"
"                                   const numtyp param_c,\n"
"                                   const numtyp param_d,\n"
"                                   const numtyp param_h,\n"
"                                   const numtyp param_gamma,\n"
"                                   numtyp drk[3])\n"
"{\n"
"  numtyp gijk,gijk_d,ex_delr,ex_delr_d,fc,dfc,cos_theta,tmp;\n"
"  numtyp dcosdri[3],dcosdrj[3],dcosdrk[3];\n"
"  fc = ters_fc(rik,param_bigr,param_bigd);\n"
"  dfc = ters_fc_d(rik,param_bigr,param_bigd);\n"
"  numtyp t = param_lam3*(rij-rik);\n"
"  if ((int)param_powermint == 3) tmp = t*t*t;\n"
"  else tmp = t;\n"
"  if (tmp > (numtyp)69.0776) ex_delr = (numtyp)1.e30;\n"
"  else if (tmp < (numtyp)-69.0776) ex_delr = (numtyp)0.0;\n"
"  else ex_delr = ucl_exp(tmp);\n"
"  if ((int)param_powermint == 3)\n"
"    ex_delr_d = (numtyp)3.0*param_lam3*t*t*ex_delr;\n"
"  else ex_delr_d = param_lam3 * ex_delr;\n"
"  cos_theta = vec3_dot(rij_hat,rik_hat);\n"
"  gijk = ters_gijk(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  gijk_d = ters_gijk_d(cos_theta,param_c,param_d,param_h,param_gamma);\n"
"  costheta_d(rij_hat,rij,rik_hat,rik,dcosdri,dcosdrj,dcosdrk);\n"
"  \n"
"  \n"
"  \n"
"  \n"
"  vec3_scale(dfc*gijk*ex_delr,rik_hat,drk);\n"
"  vec3_scaleadd(fc*gijk_d*ex_delr,dcosdrk,drk,drk);\n"
"  vec3_scaleadd(-fc*gijk*ex_delr_d,rik_hat,drk,drk);\n"
"  vec3_scale(prefactor,drk,drk);\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline void repulsive(const numtyp param_bigr,\n"
"                          const numtyp param_bigd,\n"
"                          const numtyp param_lam1,\n"
"                          const numtyp param_biga,\n"
"                          const numtyp param_Z_i,\n"
"                          const numtyp param_Z_j,\n"
"                          const numtyp param_ZBLcut,\n"
"                          const numtyp param_ZBLexpscale,\n"
"                          const numtyp global_e,\n"
"                          const numtyp global_a_0,\n"
"                          const numtyp global_epsilon_0,\n"
"                          const numtyp rsq,\n"
"                          const int eflag,\n"
"                          numtyp *ans)\n"
"{\n"
"  numtyp r,tmp_fc,tmp_fc_d,tmp_exp;\n"
"  \n"
"  r = ucl_sqrt(rsq);\n"
"  tmp_fc = ters_fc(r,param_bigr,param_bigd);\n"
"  tmp_fc_d = ters_fc_d(r,param_bigr,param_bigd);\n"
"  tmp_exp = ucl_exp(-param_lam1 * r);\n"
"  numtyp fforce_ters = param_biga * tmp_exp * (tmp_fc_d - tmp_fc*param_lam1);\n"
"  numtyp eng_ters = tmp_fc * param_biga * tmp_exp;\n"
"  \n"
"  numtyp esq = global_e*global_e;\n"
"  numtyp a_ij = ((numtyp)0.8854*global_a_0) /\n"
"    (ucl_powr(param_Z_i,(numtyp)0.23) + ucl_powr(param_Z_j,(numtyp)0.23));\n"
"  numtyp premult = (param_Z_i * param_Z_j * esq)/((numtyp)4.0*MY_PI*global_epsilon_0);\n"
"  numtyp r_ov_a = r/a_ij;\n"
"  numtyp t1 = (numtyp)0.1818*ucl_exp((numtyp)-3.2*r_ov_a);\n"
"  numtyp t2 = (numtyp)0.5099*ucl_exp((numtyp)-0.9423*r_ov_a);\n"
"  numtyp t3 = (numtyp)0.2802*ucl_exp((numtyp)-0.4029*r_ov_a);\n"
"  numtyp t4 = (numtyp)0.02817*ucl_exp((numtyp)-0.2016*r_ov_a);\n"
"  numtyp phi = t1 + t2 + t3 + t4;\n"
"  numtyp dphi = (numtyp)-3.2*t1 - (numtyp)0.9423*t2 - (numtyp)0.4029*t3 -\n"
"    (numtyp)0.2016*t4;\n"
"  dphi *= ucl_recip(a_ij);\n"
"/*\n"
"  numtyp phi = (numtyp)0.1818*ucl_exp((numtyp)-3.2*r_ov_a) +\n"
"    (numtyp)0.5099*ucl_exp((numtyp)-0.9423*r_ov_a) +\n"
"    (numtyp)0.2802*ucl_exp((numtyp)-0.4029*r_ov_a) +\n"
"    (numtyp)0.02817*ucl_exp((numtyp)-0.2016*r_ov_a);\n"
"  numtyp dphi = ucl_recip(a_ij) * ((numtyp)-3.2*(numtyp)0.1818*ucl_exp((numtyp)-3.2*r_ov_a) -\n"
"    (numtyp)0.9423*(numtyp)0.5099*ucl_exp((numtyp)-0.9423*r_ov_a) -\n"
"    (numtyp)0.4029*(numtyp)0.2802*ucl_exp((numtyp)-0.4029*r_ov_a) -\n"
"    (numtyp)0.2016*(numtyp)0.02817*ucl_exp((numtyp)-0.2016*r_ov_a));\n"
"*/\n"
"  numtyp rinv = ucl_recip(r);\n"
"  numtyp fforce_ZBL = premult*(-phi)/rsq + premult*dphi*rinv;\n"
"  numtyp eng_ZBL = premult*rinv*phi;\n"
"  \n"
"  \n"
"  numtyp f = F_fermi(r,param_ZBLcut,param_ZBLexpscale);\n"
"  numtyp f_d = F_fermi_d(r,param_ZBLcut,param_ZBLexpscale);\n"
"  ans[0] = -(-f_d * eng_ZBL + ((numtyp)1.0 - f)*fforce_ZBL + f_d*eng_ters +\n"
"             f*fforce_ters) * rinv;\n"
"  \n"
"  if (eflag) ans[1] = ((numtyp)1.0 - f)*eng_ZBL + f*eng_ters;\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline numtyp zeta(const numtyp param_powermint,\n"
"                       const numtyp param_lam3,\n"
"                       const numtyp param_bigr,\n"
"                       const numtyp param_bigd,\n"
"                       const numtyp param_c,\n"
"                       const numtyp param_d,\n"
"                       const numtyp param_h,\n"
"                       const numtyp param_gamma,\n"
"                       const numtyp rsqij,\n"
"                       const numtyp rsqik,\n"
"                       const numtyp4 delrij,\n"
"                       const numtyp4 delrik)\n"
"{\n"
"  numtyp rij,rik,costheta,arg,ex_delr;\n"
"  rij = ucl_sqrt(rsqij);\n"
"  rik = ucl_sqrt(rsqik);\n"
"  costheta = (delrij.x*delrik.x + delrij.y*delrik.y +\n"
"              delrij.z*delrik.z) / (rij*rik);\n"
"  numtyp t = param_lam3*(rij-rik);\n"
"  if ((int)param_powermint == 3) arg = t*t*t;\n"
"  else arg = t;\n"
"  if (arg > (numtyp)69.0776) ex_delr = (numtyp)1.e30;\n"
"  else if (arg < (numtyp)-69.0776) ex_delr = (numtyp)0.0;\n"
"  else ex_delr = ucl_exp(arg);\n"
"  return ters_fc(rik,param_bigr,param_bigd) *\n"
"         ters_gijk(costheta,param_c, param_d, param_h, param_gamma) * ex_delr;\n"
"}\n"
"/* ---------------------------------------------------------------------- */\n"
"ucl_inline void force_zeta(const numtyp param_bigb,\n"
"                           const numtyp param_bigr,\n"
"                           const numtyp param_bigd,\n"
"                           const numtyp param_lam2,\n"
"                           const numtyp param_beta,\n"
"                           const numtyp param_powern,\n"
"                           const numtyp param_c1,\n"
"                           const numtyp param_c2,\n"
"                           const numtyp param_c3,\n"
"                           const numtyp param_c4,\n"
"                           const numtyp param_ZBLcut,\n"
"                           const numtyp param_ZBLexpscale,\n"
"                           const numtyp rsq,\n"
"                           const numtyp zeta_ij,\n"
"                           const int eflag,\n"
"                           numtyp fpfeng[4])\n"
"{\n"
"  numtyp r,fa,fa_d,bij;\n"
"  r = ucl_sqrt(rsq);\n"
"  fa = ters_fa(r,param_bigb,param_bigr,param_bigd,param_lam2,param_ZBLcut,param_ZBLexpscale);\n"
"  fa_d = ters_fa_d(r,param_bigb,param_bigr,param_bigd,param_lam2,param_ZBLcut,param_ZBLexpscale);\n"
"  bij = ters_bij(zeta_ij,param_beta,param_powern,\n"
"                 param_c1,param_c2, param_c3, param_c4);\n"
"  fpfeng[0] = (numtyp)0.5*bij*fa_d * ucl_recip(r); \n"
"  fpfeng[1] = (numtyp)-0.5*fa * ters_bij_d(zeta_ij,param_beta, param_powern,\n"
"           param_c1,param_c2, param_c3, param_c4); \n"
"  if (eflag) fpfeng[2] = (numtyp)0.5*bij*fa; \n"
"}\n"
"/* ----------------------------------------------------------------------\n"
"   attractive term\n"
"   use param_ij cutoff for rij test\n"
"   use param_ijk cutoff for rik test\n"
"------------------------------------------------------------------------- */\n"
"ucl_inline void attractive(const numtyp param_bigr,\n"
"                           const numtyp param_bigd,\n"
"                           const numtyp param_powermint,\n"
"                           const numtyp param_lam3,\n"
"                           const numtyp param_c,\n"
"                           const numtyp param_d,\n"
"                           const numtyp param_h,\n"
"                           const numtyp param_gamma,\n"
"                           const numtyp prefactor,\n"
"                           const numtyp rij,\n"
"                           const numtyp rijinv,\n"
"                           const numtyp rik,\n"
"                           const numtyp rikinv,\n"
"                           const numtyp delrij[3],\n"
"                           const numtyp delrik[3],\n"
"                           numtyp fi[3],\n"
"                           numtyp fj[3],\n"
"                           numtyp fk[3])\n"
"{\n"
"  numtyp rij_hat[3],rik_hat[3];\n"
"  vec3_scale(rijinv,delrij,rij_hat);\n"
"  vec3_scale(rikinv,delrik,rik_hat);\n"
"  ters_zetaterm_d(prefactor,rij_hat,rij,rik_hat,rik,\n"
"                  param_bigr, param_bigd, param_powermint, param_lam3,\n"
"                  param_c, param_d, param_h, param_gamma, fi, fj, fk);\n"
"}\n"
"ucl_inline void attractive_fi(const numtyp param_bigr,\n"
"                              const numtyp param_bigd,\n"
"                              const numtyp param_powermint,\n"
"                              const numtyp param_lam3,\n"
"                              const numtyp param_c,\n"
"                              const numtyp param_d,\n"
"                              const numtyp param_h,\n"
"                              const numtyp param_gamma,\n"
"                              const numtyp prefactor,\n"
"                              const numtyp rij,\n"
"                              const numtyp rijinv,\n"
"                              const numtyp rik,\n"
"                              const numtyp rikinv,\n"
"                              const numtyp delrij[3],\n"
"                              const numtyp delrik[3],\n"
"                              numtyp fi[3])\n"
"{\n"
"  numtyp rij_hat[3],rik_hat[3];\n"
"  vec3_scale(rijinv,delrij,rij_hat);\n"
"  vec3_scale(rikinv,delrik,rik_hat);\n"
"  ters_zetaterm_d_fi(prefactor,rij_hat,rij,rik_hat,rik,\n"
"                  param_bigr, param_bigd, param_powermint, param_lam3,\n"
"                  param_c, param_d, param_h, param_gamma, fi);\n"
"}\n"
"ucl_inline void attractive_fj(const numtyp param_bigr,\n"
"                              const numtyp param_bigd,\n"
"                              const numtyp param_powermint,\n"
"                              const numtyp param_lam3,\n"
"                              const numtyp param_c,\n"
"                              const numtyp param_d,\n"
"                              const numtyp param_h,\n"
"                              const numtyp param_gamma,\n"
"                              const numtyp prefactor,\n"
"                              const numtyp rij,\n"
"                              const numtyp rijinv,\n"
"                              const numtyp rik,\n"
"                              const numtyp rikinv,\n"
"                              const numtyp delrij[3],\n"
"                              const numtyp delrik[3],\n"
"                              numtyp fj[3])\n"
"{\n"
"  numtyp rij_hat[3],rik_hat[3];\n"
"  vec3_scale(rijinv,delrij,rij_hat);\n"
"  vec3_scale(rikinv,delrik,rik_hat);\n"
"  ters_zetaterm_d_fj(prefactor,rij_hat,rij,rik_hat,rik,\n"
"                     param_bigr, param_bigd, param_powermint, param_lam3,\n"
"                     param_c, param_d, param_h, param_gamma, fj);\n"
"}\n"
"ucl_inline void attractive_fk(const numtyp param_bigr,\n"
"                              const numtyp param_bigd,\n"
"                              const numtyp param_powermint,\n"
"                              const numtyp param_lam3,\n"
"                              const numtyp param_c,\n"
"                              const numtyp param_d,\n"
"                              const numtyp param_h,\n"
"                              const numtyp param_gamma,\n"
"                              const numtyp prefactor,\n"
"                              const numtyp rij,\n"
"                              const numtyp rijinv,\n"
"                              const numtyp rik,\n"
"                              const numtyp rikinv,\n"
"                              const numtyp delrij[3],\n"
"                              const numtyp delrik[3],\n"
"                              numtyp fk[3])\n"
"{\n"
"  numtyp rij_hat[3],rik_hat[3];\n"
"  vec3_scale(rijinv,delrij,rij_hat);\n"
"  vec3_scale(rikinv,delrik,rik_hat);\n"
"  ters_zetaterm_d_fk(prefactor,rij_hat,rij,rik_hat,rik,\n"
"                     param_bigr, param_bigd, param_powermint, param_lam3,\n"
"                     param_c, param_d, param_h, param_gamma, fk);\n"
"}\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_tersoff_zbl_extra.h\"\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex,float4);\n"
"_texture( ts1_tex,float4);\n"
"_texture( ts2_tex,float4);\n"
"_texture( ts3_tex,float4);\n"
"_texture( ts4_tex,float4);\n"
"_texture( ts5_tex,float4);\n"
"_texture( ts6_tex,float4);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"_texture( ts1_tex,int4);\n"
"_texture( ts2_tex,int4);\n"
"_texture( ts3_tex,int4);\n"
"_texture( ts4_tex,int4);\n"
"_texture( ts5_tex,int4);\n"
"_texture( ts6_tex,int4);\n"
"#endif\n"
"#else\n"
"#define pos_tex x_\n"
"#define ts1_tex ts1\n"
"#define ts2_tex ts2\n"
"#define ts3_tex ts3\n"
"#define ts4_tex ts4\n"
"#define ts5_tex ts5\n"
"#define ts6_tex ts6\n"
"#endif\n"
"#define TWOTHIRD (numtyp)0.66666666666666666667\n"
"#define zeta_idx(nbor_mem, packed_mem, nbor_pitch, n_stride, t_per_atom,    \\\n"
"                 i, nbor_j, offset_j, idx)                                  \\\n"
"  if (nbor_mem==packed_mem) {                                               \\\n"
"    int jj = (nbor_j-offset_j-2*nbor_pitch)/n_stride;                       \\\n"
"    idx = jj*n_stride + i*t_per_atom + offset_j;                            \\\n"
"  } else {                                                                  \\\n"
"    idx = nbor_j;                                                           \\\n"
"  }\n"
"#if (ARCH < 300)\n"
"#define store_answers_p(f, energy, virial, ii, inum, tid, t_per_atom,       \\\n"
"                        offset, eflag, vflag, ans, engv)                    \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];                                  \\\n"
"    red_acc[0][tid]=f.x;                                                    \\\n"
"    red_acc[1][tid]=f.y;                                                    \\\n"
"    red_acc[2][tid]=f.z;                                                    \\\n"
"    red_acc[3][tid]=energy;                                                 \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        for (int r=0; r<4; r++)                                             \\\n"
"          red_acc[r][tid] += red_acc[r][tid+s];                             \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    f.x=red_acc[0][tid];                                                    \\\n"
"    f.y=red_acc[1][tid];                                                    \\\n"
"    f.z=red_acc[2][tid];                                                    \\\n"
"    energy=red_acc[3][tid];                                                 \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        red_acc[r][tid]=virial[r];                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"        if (offset < s) {                                                   \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            red_acc[r][tid] += red_acc[r][tid+s];                           \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      for (int r=0; r<6; r++)                                               \\\n"
"        virial[r]=red_acc[r][tid];                                          \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]+=energy*(acctyp)0.5;                                         \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]+=virial[i]*(acctyp)0.5;                                    \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#define acc_zeta(z, tid, t_per_atom, offset)                                \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    __local acctyp red_acc[BLOCK_PAIR];                                     \\\n"
"    red_acc[tid]=z;                                                         \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      if (offset < s) {                                                     \\\n"
"        red_acc[tid] += red_acc[tid+s];                                     \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    z=red_acc[tid];                                                         \\\n"
"  }\n"
"#else\n"
"#define store_answers_p(f, energy, virial, ii, inum, tid, t_per_atom,       \\\n"
"                        offset, eflag, vflag, ans, engv)                    \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      f.x += shfl_xor(f.x, s, t_per_atom);                                  \\\n"
"      f.y += shfl_xor(f.y, s, t_per_atom);                                  \\\n"
"      f.z += shfl_xor(f.z, s, t_per_atom);                                  \\\n"
"      energy += shfl_xor(energy, s, t_per_atom);                            \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                       \\\n"
"          for (int r=0; r<6; r++)                                           \\\n"
"            virial[r] += shfl_xor(virial[r], s, t_per_atom);                \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    int ei=ii;                                                              \\\n"
"    if (eflag>0) {                                                          \\\n"
"      engv[ei]+=energy*(acctyp)0.5;                                         \\\n"
"      ei+=inum;                                                             \\\n"
"    }                                                                       \\\n"
"    if (vflag>0) {                                                          \\\n"
"      for (int i=0; i<6; i++) {                                             \\\n"
"        engv[ei]+=virial[i]*(acctyp)0.5;                                    \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    acctyp4 old=ans[ii];                                                    \\\n"
"    old.x+=f.x;                                                             \\\n"
"    old.y+=f.y;                                                             \\\n"
"    old.z+=f.z;                                                             \\\n"
"    ans[ii]=old;                                                            \\\n"
"  }\n"
"#define acc_zeta(z, tid, t_per_atom, offset)                                \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    for (unsigned int s=t_per_atom/2; s>0; s>>=1) {                         \\\n"
"      z += shfl_xor(z, s, t_per_atom);                                      \\\n"
"    }                                                                       \\\n"
"  }\n"
"#endif\n"
"__kernel void k_tersoff_zbl_short_nbor(const __global numtyp4 *restrict x_,\n"
"                                   const __global int * dev_nbor,\n"
"                                   const __global int * dev_packed,\n"
"                                   __global int * dev_short_nbor,\n"
"                                   const numtyp _cutshortsq,\n"
"                                   const int inum, const int nbor_pitch,\n"
"                                   const int t_per_atom) {\n"
"  __local int n_stride;\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end;\n"
"    int i, numj;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int ncount = 0;\n"
"    int m = nbor;\n"
"    dev_short_nbor[m] = 0;\n"
"    int nbor_short = nbor+n_stride;\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=dev_packed[nbor];\n"
"      int nj = j;\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      if (rsq<_cutshortsq) {\n"
"        dev_short_nbor[nbor_short] = nj;\n"
"        nbor_short += n_stride;\n"
"        ncount++;\n"
"      }\n"
"    } \n"
"    \n"
"    dev_short_nbor[m] = ncount;\n"
"  } \n"
"}\n"
"#define SHARED_SIZE 32\n"
"__kernel void k_tersoff_zbl_zeta(const __global numtyp4 *restrict x_,\n"
"                             const __global numtyp4 *restrict ts1_in,\n"
"                             const __global numtyp4 *restrict ts2_in,\n"
"                             const __global numtyp4 *restrict ts3_in,\n"
"                             const __global numtyp4 *restrict ts4_in,\n"
"                             const __global numtyp4 *restrict ts5_in,\n"
"                             const __global numtyp4 *restrict ts6_in,\n"
"                             const __global numtyp *restrict cutsq,\n"
"                             const __global int *restrict map,\n"
"                             const __global int *restrict elem2param,\n"
"                             const int nelements, const int nparams,\n"
"                             __global acctyp4 * zetaij,\n"
"                             const __global int * dev_nbor,\n"
"                             const __global int * dev_packed,\n"
"                             const __global int * dev_short_nbor,\n"
"                             const int eflag, const int inum,\n"
"                             const int nbor_pitch, const int t_per_atom) {\n"
"  __local int tpa_sq,n_stride;\n"
"  tpa_sq = fast_mul(t_per_atom,t_per_atom);\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  \n"
"  __local numtyp4 ts1[SHARED_SIZE];\n"
"  __local numtyp4 ts2[SHARED_SIZE];\n"
"  __local numtyp4 ts3[SHARED_SIZE];\n"
"  __local numtyp4 ts4[SHARED_SIZE];\n"
"  __local numtyp4 ts5[SHARED_SIZE];\n"
"  __local numtyp4 ts6[SHARED_SIZE];\n"
"  if (tid<nparams) {\n"
"    ts1[tid]=ts1_in[tid];\n"
"    ts2[tid]=ts2_in[tid];\n"
"    ts3[tid]=ts3_in[tid];\n"
"    ts4[tid]=ts4_in[tid];\n"
"    ts5[tid]=ts5_in[tid];\n"
"    ts6[tid]=ts6_in[tid];\n"
"  }\n"
"  acctyp z = (acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor_j, nbor_end, i, numj;\n"
"    const __global int* nbor_mem=dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    int nborj_start = nbor_j;\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      \n"
"      numtyp4 delr1, delr2;\n"
"      delr1.x = jx.x-ix.x;\n"
"      delr1.y = jx.y-ix.y;\n"
"      delr1.z = jx.z-ix.z;\n"
"      numtyp rsq1 = delr1.x*delr1.x+delr1.y*delr1.y+delr1.z*delr1.z;\n"
"      \n"
"      z = (acctyp)0;\n"
"      int nbor_k = nborj_start-offset_j+offset_k;\n"
"      int k_end = nbor_end;\n"
"      if (dev_packed==dev_nbor) {\n"
"        int numk = dev_short_nbor[nbor_k-n_stride];\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      for ( ; nbor_k < k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == j) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex); \n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int ijkparam=elem2param[itype*nelements*nelements+jtype*nelements+ktype];\n"
"        \n"
"        delr2.x = kx.x-ix.x;\n"
"        delr2.y = kx.y-ix.y;\n"
"        delr2.z = kx.z-ix.z;\n"
"        numtyp rsq2 = delr2.x*delr2.x+delr2.y*delr2.y+delr2.z*delr2.z;\n"
"        if (rsq2 > cutsq[ijkparam]) continue;\n"
"        numtyp4 ts1_ijkparam = ts1[ijkparam]; \n"
"        numtyp ijkparam_lam3 = ts1_ijkparam.z;\n"
"        numtyp ijkparam_powermint = ts1_ijkparam.w;\n"
"        numtyp4 ts2_ijkparam = ts2[ijkparam]; \n"
"        numtyp ijkparam_bigr = ts2_ijkparam.z;\n"
"        numtyp ijkparam_bigd = ts2_ijkparam.w;\n"
"        numtyp4 ts4_ijkparam = ts4[ijkparam]; \n"
"        numtyp ijkparam_c = ts4_ijkparam.x;\n"
"        numtyp ijkparam_d = ts4_ijkparam.y;\n"
"        numtyp ijkparam_h = ts4_ijkparam.z;\n"
"        numtyp ijkparam_gamma = ts4_ijkparam.w;\n"
"        z += zeta(ijkparam_powermint, ijkparam_lam3, ijkparam_bigr, ijkparam_bigd,\n"
"                  ijkparam_c, ijkparam_d, ijkparam_h, ijkparam_gamma,\n"
"                  rsq1, rsq2, delr1, delr2);\n"
"      }\n"
"      \n"
"      int idx = nbor_j;\n"
"      if (dev_packed==dev_nbor) idx -= n_stride;\n"
"      acc_zeta(z, tid, t_per_atom, offset_k);\n"
"      numtyp4 ts1_ijparam = ts1[ijparam]; \n"
"      numtyp ijparam_lam2 = ts1_ijparam.y;\n"
"      numtyp4 ts2_ijparam = ts2[ijparam]; \n"
"      numtyp ijparam_bigb = ts2_ijparam.y;\n"
"      numtyp ijparam_bigr = ts2_ijparam.z;\n"
"      numtyp ijparam_bigd = ts2_ijparam.w;\n"
"      numtyp4 ts3_ijparam = ts3[ijparam]; \n"
"      numtyp ijparam_c1 = ts3_ijparam.x;\n"
"      numtyp ijparam_c2 = ts3_ijparam.y;\n"
"      numtyp ijparam_c3 = ts3_ijparam.z;\n"
"      numtyp ijparam_c4 = ts3_ijparam.w;\n"
"      numtyp4 ts5_ijparam = ts5[ijparam]; \n"
"      numtyp ijparam_beta = ts5_ijparam.x;\n"
"      numtyp ijparam_powern = ts5_ijparam.y;\n"
"      numtyp4 ts6_ijparam = ts6[ijparam]; \n"
"      numtyp ijparam_ZBLcut = ts6_ijparam.z;\n"
"      numtyp ijparam_ZBLexpscale = ts6_ijparam.w;\n"
"      if (offset_k == 0) {\n"
"        numtyp fpfeng[4];\n"
"        force_zeta(ijparam_bigb, ijparam_bigr, ijparam_bigd, ijparam_lam2,\n"
"                   ijparam_beta, ijparam_powern, ijparam_c1, ijparam_c2, ijparam_c3,\n"
"                   ijparam_c4, ijparam_ZBLcut, ijparam_ZBLexpscale, rsq1, z, eflag, fpfeng);\n"
"        acctyp4 zij;\n"
"        zij.x = fpfeng[0];\n"
"        zij.y = fpfeng[1];\n"
"        zij.z = fpfeng[2];\n"
"        zij.w = z;\n"
"        zetaij[idx] = zij;\n"
"      }\n"
"    } \n"
"  } \n"
"}\n"
"__kernel void k_tersoff_zbl_repulsive(const __global numtyp4 *restrict x_,\n"
"                                  const __global numtyp4 *restrict ts1_in,\n"
"                                  const __global numtyp4 *restrict ts2_in,\n"
"                                  const __global numtyp4 *restrict ts6_in,\n"
"                                  const numtyp global_e, const numtyp global_a_0,\n"
"                                  const numtyp global_epsilon_0,\n"
"                                  const __global numtyp *restrict cutsq,\n"
"                                  const __global int *restrict map,\n"
"                                  const __global int *restrict elem2param,\n"
"                                  const int nelements, const int nparams,\n"
"                                  const __global int * dev_nbor,\n"
"                                  const __global int * dev_packed,\n"
"                                  const __global int * dev_short_nbor,\n"
"                                  __global acctyp4 *restrict ans,\n"
"                                  __global acctyp *restrict engv,\n"
"                                  const int eflag, const int vflag,\n"
"                                  const int inum, const int nbor_pitch,\n"
"                                  const int t_per_atom) {\n"
"  __local int n_stride;\n"
"  int tid, ii, offset;\n"
"  atom_info(t_per_atom,ii,tid,offset);\n"
"  __local numtyp4 ts1[SHARED_SIZE];\n"
"  __local numtyp4 ts2[SHARED_SIZE];\n"
"  __local numtyp4 ts6[SHARED_SIZE];\n"
"  if (tid<nparams) {\n"
"    ts1[tid]=ts1_in[tid];\n"
"    ts2[tid]=ts2_in[tid];\n"
"    ts6[tid]=ts6_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int nbor, nbor_end, i, numj;\n"
"    const __global int* nbor_mem=dev_packed;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset,i,numj,\n"
"              n_stride,nbor_end,nbor);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor];\n"
"      nbor += n_stride;\n"
"      nbor_end = nbor+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor<nbor_end; nbor+=n_stride) {\n"
"      int j=nbor_mem[nbor];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      \n"
"      numtyp delx = ix.x-jx.x;\n"
"      numtyp dely = ix.y-jx.y;\n"
"      numtyp delz = ix.z-jx.z;\n"
"      numtyp rsq = delx*delx+dely*dely+delz*delz;\n"
"      if (rsq >= cutsq[ijparam]) continue;\n"
"      numtyp feng[2];\n"
"      numtyp ijparam_lam1 = ts1[ijparam].x;\n"
"      numtyp4 ts2_ijparam = ts2[ijparam];\n"
"      numtyp ijparam_biga = ts2_ijparam.x;\n"
"      numtyp ijparam_bigr = ts2_ijparam.z;\n"
"      numtyp ijparam_bigd = ts2_ijparam.w;\n"
"      numtyp4 ts6_ijparam = ts6[ijparam];\n"
"      numtyp ijparam_Z_i = ts6_ijparam.x;\n"
"      numtyp ijparam_Z_j = ts6_ijparam.y;\n"
"      numtyp ijparam_ZBLcut = ts6_ijparam.z;\n"
"      numtyp ijparam_ZBLexpscale = ts6_ijparam.w;\n"
"      repulsive(ijparam_bigr, ijparam_bigd, ijparam_lam1, ijparam_biga,\n"
"                ijparam_Z_i, ijparam_Z_j, ijparam_ZBLcut, ijparam_ZBLexpscale,\n"
"                global_e, global_a_0, global_epsilon_0, rsq, eflag, feng);\n"
"      numtyp force = feng[0];\n"
"      f.x+=delx*force;\n"
"      f.y+=dely*force;\n"
"      f.z+=delz*force;\n"
"      if (eflag>0)\n"
"        energy+=feng[1];\n"
"      if (vflag>0) {\n"
"        virial[0] += delx*delx*force;\n"
"        virial[1] += dely*dely*force;\n"
"        virial[2] += delz*delz*force;\n"
"        virial[3] += delx*dely*force;\n"
"        virial[4] += delx*delz*force;\n"
"        virial[5] += dely*delz*force;\n"
"      }\n"
"    } \n"
"    store_answers(f,energy,virial,ii,inum,tid,t_per_atom,offset,eflag,vflag,\n"
"                  ans,engv);\n"
"  } \n"
"}\n"
"__kernel void k_tersoff_zbl_three_center(const __global numtyp4 *restrict x_,\n"
"                                     const __global numtyp4 *restrict ts1_in,\n"
"                                     const __global numtyp4 *restrict ts2_in,\n"
"                                     const __global numtyp4 *restrict ts4_in,\n"
"                                     const __global numtyp *restrict cutsq,\n"
"                                     const __global int *restrict map,\n"
"                                     const __global int *restrict elem2param,\n"
"                                     const int nelements, const int nparams,\n"
"                                     const __global acctyp4 *restrict zetaij,\n"
"                                     const __global int * dev_nbor,\n"
"                                     const __global int * dev_packed,\n"
"                                     const __global int * dev_short_nbor,\n"
"                                     __global acctyp4 *restrict ans,\n"
"                                     __global acctyp *restrict engv,\n"
"                                     const int eflag, const int vflag,\n"
"                                     const int inum,  const int nbor_pitch,\n"
"                                     const int t_per_atom, const int evatom) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp lam3, powermint, bigr, bigd, c, d, h, gamma;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset); \n"
"  __local numtyp4 ts1[SHARED_SIZE];\n"
"  __local numtyp4 ts2[SHARED_SIZE];\n"
"  __local numtyp4 ts4[SHARED_SIZE];\n"
"  if (tid<nparams) {\n"
"    ts1[tid]=ts1_in[tid];\n"
"    ts2[tid]=ts2_in[tid];\n"
"    ts4[tid]=ts4_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  numtyp tpainv = ucl_recip((numtyp)t_per_atom);\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end;\n"
"    const __global int* nbor_mem=dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    int nborj_start = nbor_j;\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      int ijparam=elem2param[itype*nelements*nelements+jtype*nelements+jtype];\n"
"      \n"
"      numtyp delr1[3];\n"
"      delr1[0] = jx.x-ix.x;\n"
"      delr1[1] = jx.y-ix.y;\n"
"      delr1[2] = jx.z-ix.z;\n"
"      numtyp rsq1 = delr1[0]*delr1[0] + delr1[1]*delr1[1] + delr1[2]*delr1[2];\n"
"      if (rsq1 >= cutsq[ijparam]) continue;\n"
"      numtyp r1 = ucl_sqrt(rsq1);\n"
"      numtyp r1inv = ucl_rsqrt(rsq1);\n"
"      \n"
"      \n"
"      int idx = nbor_j;\n"
"      if (dev_packed==dev_nbor) idx -= n_stride;\n"
"      acctyp4 zeta_ij = zetaij[idx]; \n"
"      numtyp force = zeta_ij.x*tpainv;\n"
"      numtyp prefactor = zeta_ij.y;\n"
"      f.x += delr1[0]*force;\n"
"      f.y += delr1[1]*force;\n"
"      f.z += delr1[2]*force;\n"
"      if (eflag>0) {\n"
"        energy+=zeta_ij.z*tpainv;\n"
"      }\n"
"      if (vflag>0) {\n"
"        numtyp mforce = -force;\n"
"        virial[0] += delr1[0]*delr1[0]*mforce;\n"
"        virial[1] += delr1[1]*delr1[1]*mforce;\n"
"        virial[2] += delr1[2]*delr1[2]*mforce;\n"
"        virial[3] += delr1[0]*delr1[1]*mforce;\n"
"        virial[4] += delr1[0]*delr1[2]*mforce;\n"
"        virial[5] += delr1[1]*delr1[2]*mforce;\n"
"      }\n"
"      int nbor_k = nborj_start-offset_j+offset_k;\n"
"      int k_end = nbor_end;\n"
"      if (dev_packed==dev_nbor) {\n"
"        int numk = dev_short_nbor[nbor_k-n_stride];\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (j == k) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int ijkparam=elem2param[itype*nelements*nelements+jtype*nelements+ktype];\n"
"        numtyp delr2[3];\n"
"        delr2[0] = kx.x-ix.x;\n"
"        delr2[1] = kx.y-ix.y;\n"
"        delr2[2] = kx.z-ix.z;\n"
"        numtyp rsq2 = delr2[0]*delr2[0] + delr2[1]*delr2[1] + delr2[2]*delr2[2];\n"
"        if (rsq2 > cutsq[ijkparam]) continue;\n"
"        numtyp r2 = ucl_sqrt(rsq2);\n"
"        numtyp r2inv = ucl_rsqrt(rsq2);\n"
"        numtyp fi[3], fj[3], fk[3];\n"
"        numtyp4 ts1_ijkparam = ts1[ijkparam]; \n"
"        lam3 = ts1_ijkparam.z;\n"
"        powermint = ts1_ijkparam.w;\n"
"        numtyp4 ts2_ijkparam = ts2[ijkparam]; \n"
"        bigr = ts2_ijkparam.z;\n"
"        bigd = ts2_ijkparam.w;\n"
"        numtyp4 ts4_ijkparam = ts4[ijkparam]; \n"
"        c = ts4_ijkparam.x;\n"
"        d = ts4_ijkparam.y;\n"
"        h = ts4_ijkparam.z;\n"
"        gamma = ts4_ijkparam.w;\n"
"        if (vflag>0)\n"
"          attractive(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                     prefactor, r1, r1inv, r2, r2inv, delr1, delr2, fi, fj, fk);\n"
"        else\n"
"          attractive_fi(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                        prefactor, r1, r1inv, r2, r2inv, delr1, delr2, fi);\n"
"        f.x += fi[0];\n"
"        f.y += fi[1];\n"
"        f.z += fi[2];\n"
"        if (vflag>0) {\n"
"          acctyp v[6];\n"
"          numtyp pre = (numtyp)2.0;\n"
"          if (evatom==1) pre = TWOTHIRD;\n"
"          v[0] = pre*(delr1[0]*fj[0] + delr2[0]*fk[0]);\n"
"          v[1] = pre*(delr1[1]*fj[1] + delr2[1]*fk[1]);\n"
"          v[2] = pre*(delr1[2]*fj[2] + delr2[2]*fk[2]);\n"
"          v[3] = pre*(delr1[0]*fj[1] + delr2[0]*fk[1]);\n"
"          v[4] = pre*(delr1[0]*fj[2] + delr2[0]*fk[2]);\n"
"          v[5] = pre*(delr1[1]*fj[2] + delr2[1]*fk[2]);\n"
"          virial[0] += v[0]; virial[1] += v[1]; virial[2] += v[2];\n"
"          virial[3] += v[3]; virial[4] += v[4]; virial[5] += v[5];\n"
"        }\n"
"      } \n"
"    } \n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,\n"
"                     offset,eflag,vflag,ans,engv);\n"
"  } \n"
"}\n"
"__kernel void k_tersoff_zbl_three_end(const __global numtyp4 *restrict x_,\n"
"                                  const __global numtyp4 *restrict ts1_in,\n"
"                                  const __global numtyp4 *restrict ts2_in,\n"
"                                  const __global numtyp4 *restrict ts4_in,\n"
"                                  const __global numtyp *restrict cutsq,\n"
"                                  const __global int *restrict map,\n"
"                                  const __global int *restrict elem2param,\n"
"                                  const int nelements, const int nparams,\n"
"                                  const __global acctyp4 *restrict zetaij,\n"
"                                  const __global int * dev_nbor,\n"
"                                  const __global int * dev_packed,\n"
"                                  const __global int * dev_ilist,\n"
"                                  const __global int * dev_short_nbor,\n"
"                                  __global acctyp4 *restrict ans,\n"
"                                  __global acctyp *restrict engv,\n"
"                                  const int eflag, const int vflag,\n"
"                                  const int inum,  const int nbor_pitch,\n"
"                                  const int t_per_atom, const int gpu_nbor) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp lam3, powermint, bigr, bigd, c, d, h, gamma;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  __local numtyp4 ts1[SHARED_SIZE];\n"
"  __local numtyp4 ts2[SHARED_SIZE];\n"
"  __local numtyp4 ts4[SHARED_SIZE];\n"
"  if (tid<nparams) {\n"
"    ts1[tid]=ts1_in[tid];\n"
"    ts2[tid]=ts2_in[tid];\n"
"    ts4[tid]=ts4_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __local int ijnum_shared[BLOCK_PAIR];\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end, k_end;\n"
"    const __global int* nbor_mem=dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    numtyp tpainv = ucl_recip((numtyp)t_per_atom);\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      \n"
"      numtyp delr1[3];\n"
"      delr1[0] = jx.x-ix.x;\n"
"      delr1[1] = jx.y-ix.y;\n"
"      delr1[2] = jx.z-ix.z;\n"
"      numtyp rsq1 = delr1[0]*delr1[0] + delr1[1]*delr1[1] + delr1[2]*delr1[2];\n"
"      numtyp mdelr1[3];\n"
"      mdelr1[0] = -delr1[0];\n"
"      mdelr1[1] = -delr1[1];\n"
"      mdelr1[2] = -delr1[2];\n"
"      int nbor_k,numk;\n"
"      if (dev_nbor==dev_packed) {\n"
"        if (gpu_nbor) nbor_k=j+nbor_pitch;\n"
"        else nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch+fast_mul(j,t_per_atom-1);\n"
"        k_end=nbor_k+fast_mul(numk/t_per_atom,n_stride)+(numk & (t_per_atom-1));\n"
"        nbor_k+=offset_k;\n"
"      } else {\n"
"        nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch;\n"
"        nbor_k=dev_nbor[nbor_k];\n"
"        k_end=nbor_k+numk;\n"
"        nbor_k+=offset_k;\n"
"      }\n"
"      \n"
"      if (dev_packed==dev_nbor) {\n"
"        numk = dev_short_nbor[nbor_k];\n"
"        nbor_k += n_stride;\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      int nbork_start = nbor_k;\n"
"      \n"
"      int m = tid / t_per_atom;\n"
"      int ijnum = -1;\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) {\n"
"          ijnum = nbor_k;\n"
"          ijnum_shared[m] = ijnum;\n"
"          break;\n"
"        }\n"
"      }\n"
"      numtyp r1 = ucl_sqrt(rsq1);\n"
"      numtyp r1inv = ucl_rsqrt(rsq1);\n"
"      if (ijnum < 0) ijnum = ijnum_shared[m];\n"
"      \n"
"      int idx = ijnum;\n"
"      if (dev_packed==dev_nbor) idx -= n_stride;\n"
"      acctyp4 zeta_ji = zetaij[idx]; \n"
"      numtyp force = zeta_ji.x*tpainv;\n"
"      numtyp prefactor_ji = zeta_ji.y;\n"
"      f.x += delr1[0]*force;\n"
"      f.y += delr1[1]*force;\n"
"      f.z += delr1[2]*force;\n"
"      if (eflag>0) {\n"
"        energy+=zeta_ji.z*tpainv;\n"
"      }\n"
"      if (vflag>0) {\n"
"        numtyp mforce = -force;\n"
"        virial[0] += mdelr1[0]*mdelr1[0]*mforce;\n"
"        virial[1] += mdelr1[1]*mdelr1[1]*mforce;\n"
"        virial[2] += mdelr1[2]*mdelr1[2]*mforce;\n"
"        virial[3] += mdelr1[0]*mdelr1[1]*mforce;\n"
"        virial[4] += mdelr1[0]*mdelr1[2]*mforce;\n"
"        virial[5] += mdelr1[1]*mdelr1[2]*mforce;\n"
"      }\n"
"      \n"
"      for (nbor_k = nbork_start ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int jikparam=elem2param[jtype*nelements*nelements+itype*nelements+ktype];\n"
"        numtyp delr2[3];\n"
"        delr2[0] = kx.x-jx.x;\n"
"        delr2[1] = kx.y-jx.y;\n"
"        delr2[2] = kx.z-jx.z;\n"
"        numtyp rsq2 = delr2[0]*delr2[0] + delr2[1]*delr2[1] + delr2[2]*delr2[2];\n"
"        numtyp r2 = ucl_sqrt(rsq2);\n"
"        numtyp r2inv = ucl_rsqrt(rsq2);\n"
"        numtyp4 ts1_param, ts2_param, ts4_param;\n"
"        numtyp fi[3];\n"
"        ts1_param = ts1[jikparam]; \n"
"        lam3 = ts1_param.z;\n"
"        powermint = ts1_param.w;\n"
"        ts2_param = ts2[jikparam]; \n"
"        bigr = ts2_param.z;\n"
"        bigd = ts2_param.w;\n"
"        ts4_param = ts4[jikparam]; \n"
"        c = ts4_param.x;\n"
"        d = ts4_param.y;\n"
"        h = ts4_param.z;\n"
"        gamma = ts4_param.w;\n"
"        attractive_fj(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                      prefactor_ji, r1, r1inv, r2, r2inv, mdelr1, delr2, fi);\n"
"        f.x += fi[0];\n"
"        f.y += fi[1];\n"
"        f.z += fi[2];\n"
"        \n"
"        int idx = nbor_k;\n"
"        if (dev_packed==dev_nbor) idx -= n_stride;\n"
"        acctyp4 zeta_jk = zetaij[idx]; \n"
"        numtyp prefactor_jk = zeta_jk.y;\n"
"        int jkiparam=elem2param[jtype*nelements*nelements+ktype*nelements+itype];\n"
"        ts1_param = ts1[jkiparam]; \n"
"        lam3 = ts1_param.z;\n"
"        powermint = ts1_param.w;\n"
"        ts2_param = ts2[jkiparam]; \n"
"        bigr = ts2_param.z;\n"
"        bigd = ts2_param.w;\n"
"        ts4_param = ts4[jkiparam]; \n"
"        c = ts4_param.x;\n"
"        d = ts4_param.y;\n"
"        h = ts4_param.z;\n"
"        gamma = ts4_param.w;\n"
"        attractive_fk(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                      prefactor_jk, r2, r2inv, r1, r1inv, delr2, mdelr1, fi);\n"
"        f.x += fi[0];\n"
"        f.y += fi[1];\n"
"        f.z += fi[2];\n"
"      } \n"
"    } \n"
"    #ifdef THREE_CONCURRENT\n"
"    store_answers(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                  eflag,vflag,ans,engv);\n"
"    #else\n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                    eflag,vflag,ans,engv);\n"
"    #endif\n"
"  } \n"
"}\n"
"__kernel void k_tersoff_zbl_three_end_vatom(const __global numtyp4 *restrict x_,\n"
"                                        const __global numtyp4 *restrict ts1_in,\n"
"                                        const __global numtyp4 *restrict ts2_in,\n"
"                                        const __global numtyp4 *restrict ts4_in,\n"
"                                        const __global numtyp *restrict cutsq,\n"
"                                        const __global int *restrict map,\n"
"                                        const __global int *restrict elem2param,\n"
"                                        const int nelements, const int nparams,\n"
"                                        const __global acctyp4 *restrict zetaij,\n"
"                                        const __global int * dev_nbor,\n"
"                                        const __global int * dev_packed,\n"
"                                        const __global int * dev_ilist,\n"
"                                        const __global int * dev_short_nbor,\n"
"                                        __global acctyp4 *restrict ans,\n"
"                                        __global acctyp *restrict engv,\n"
"                                        const int eflag, const int vflag,\n"
"                                        const int inum,  const int nbor_pitch,\n"
"                                        const int t_per_atom, const int gpu_nbor) {\n"
"  __local int tpa_sq, n_stride;\n"
"  tpa_sq=fast_mul(t_per_atom,t_per_atom);\n"
"  numtyp lam3, powermint, bigr, bigd, c, d, h, gamma;\n"
"  int tid, ii, offset;\n"
"  atom_info(tpa_sq,ii,tid,offset);\n"
"  __local numtyp4 ts1[SHARED_SIZE];\n"
"  __local numtyp4 ts2[SHARED_SIZE];\n"
"  __local numtyp4 ts4[SHARED_SIZE];\n"
"  if (tid<nparams) {\n"
"    ts1[tid]=ts1_in[tid];\n"
"    ts2[tid]=ts2_in[tid];\n"
"    ts4[tid]=ts4_in[tid];\n"
"  }\n"
"  acctyp energy=(acctyp)0;\n"
"  acctyp4 f;\n"
"  f.x=(acctyp)0; f.y=(acctyp)0; f.z=(acctyp)0;\n"
"  acctyp virial[6];\n"
"  for (int i=0; i<6; i++)\n"
"    virial[i]=(acctyp)0;\n"
"  __local int red_acc[BLOCK_PAIR];\n"
"  __syncthreads();\n"
"  if (ii<inum) {\n"
"    int i, numj, nbor_j, nbor_end, k_end;\n"
"    const __global int* nbor_mem = dev_packed;\n"
"    int offset_j=offset/t_per_atom;\n"
"    nbor_info(dev_nbor,dev_packed,nbor_pitch,t_per_atom,ii,offset_j,i,numj,\n"
"              n_stride,nbor_end,nbor_j);\n"
"    int offset_k=tid & (t_per_atom-1);\n"
"    numtyp4 ix; fetch4(ix,i,pos_tex); \n"
"    int itype=ix.w;\n"
"    itype=map[itype];\n"
"    numtyp tpainv = ucl_recip((numtyp)t_per_atom);\n"
"    \n"
"    if (dev_packed==dev_nbor) {\n"
"      numj = dev_short_nbor[nbor_j];\n"
"      nbor_j += n_stride;\n"
"      nbor_end = nbor_j+fast_mul(numj,n_stride);\n"
"      nbor_mem = dev_short_nbor;\n"
"    }\n"
"    for ( ; nbor_j<nbor_end; nbor_j+=n_stride) {\n"
"      int j=nbor_mem[nbor_j];\n"
"      j &= NEIGHMASK;\n"
"      numtyp4 jx; fetch4(jx,j,pos_tex); \n"
"      int jtype=jx.w;\n"
"      jtype=map[jtype];\n"
"      \n"
"      numtyp delr1[3];\n"
"      delr1[0] = jx.x-ix.x;\n"
"      delr1[1] = jx.y-ix.y;\n"
"      delr1[2] = jx.z-ix.z;\n"
"      numtyp rsq1 = delr1[0]*delr1[0] + delr1[1]*delr1[1] + delr1[2]*delr1[2];\n"
"      numtyp mdelr1[3];\n"
"      mdelr1[0] = -delr1[0];\n"
"      mdelr1[1] = -delr1[1];\n"
"      mdelr1[2] = -delr1[2];\n"
"      int nbor_k,numk;\n"
"      if (dev_nbor==dev_packed) {\n"
"        if (gpu_nbor) nbor_k=j+nbor_pitch;\n"
"        else nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch+fast_mul(j,t_per_atom-1);\n"
"        k_end=nbor_k+fast_mul(numk/t_per_atom,n_stride)+(numk & (t_per_atom-1));\n"
"        nbor_k+=offset_k;\n"
"      } else {\n"
"        nbor_k=dev_ilist[j]+nbor_pitch;\n"
"        numk=dev_nbor[nbor_k];\n"
"        nbor_k+=nbor_pitch;\n"
"        nbor_k=dev_nbor[nbor_k];\n"
"        k_end=nbor_k+numk;\n"
"        nbor_k+=offset_k;\n"
"      }\n"
"      \n"
"      if (dev_packed==dev_nbor) {\n"
"        numk = dev_short_nbor[nbor_k];\n"
"        nbor_k += n_stride;\n"
"        k_end = nbor_k+fast_mul(numk,n_stride);\n"
"      }\n"
"      int nbork_start = nbor_k;\n"
"      \n"
"      int m = tid / t_per_atom;\n"
"      int ijnum = -1;\n"
"      for ( ; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) {\n"
"          ijnum = nbor_k;\n"
"          red_acc[m] = ijnum;\n"
"          break;\n"
"        }\n"
"      }\n"
"      numtyp r1 = ucl_sqrt(rsq1);\n"
"      numtyp r1inv = ucl_rsqrt(rsq1);\n"
"      if (ijnum < 0) ijnum = red_acc[m];\n"
"      \n"
"      int idx = ijnum;\n"
"      if (dev_packed==dev_nbor) idx -= n_stride;\n"
"      acctyp4 zeta_ji = zetaij[idx]; \n"
"      numtyp force = zeta_ji.x*tpainv;\n"
"      numtyp prefactor_ji = zeta_ji.y;\n"
"      f.x += delr1[0]*force;\n"
"      f.y += delr1[1]*force;\n"
"      f.z += delr1[2]*force;\n"
"      if (eflag>0) {\n"
"        energy+=zeta_ji.z*tpainv;\n"
"      }\n"
"      if (vflag>0) {\n"
"        numtyp mforce = -force;\n"
"        virial[0] += mdelr1[0]*mdelr1[0]*mforce;\n"
"        virial[1] += mdelr1[1]*mdelr1[1]*mforce;\n"
"        virial[2] += mdelr1[2]*mdelr1[2]*mforce;\n"
"        virial[3] += mdelr1[0]*mdelr1[1]*mforce;\n"
"        virial[4] += mdelr1[0]*mdelr1[2]*mforce;\n"
"        virial[5] += mdelr1[1]*mdelr1[2]*mforce;\n"
"      }\n"
"      \n"
"      for (nbor_k = nbork_start; nbor_k<k_end; nbor_k+=n_stride) {\n"
"        int k=nbor_mem[nbor_k];\n"
"        k &= NEIGHMASK;\n"
"        if (k == i) continue;\n"
"        numtyp4 kx; fetch4(kx,k,pos_tex);\n"
"        int ktype=kx.w;\n"
"        ktype=map[ktype];\n"
"        int jikparam=elem2param[jtype*nelements*nelements+itype*nelements+ktype];\n"
"        numtyp delr2[3];\n"
"        delr2[0] = kx.x-jx.x;\n"
"        delr2[1] = kx.y-jx.y;\n"
"        delr2[2] = kx.z-jx.z;\n"
"        numtyp rsq2 = delr2[0]*delr2[0] + delr2[1]*delr2[1] + delr2[2]*delr2[2];\n"
"        if (rsq2 > cutsq[jikparam]) continue;\n"
"        numtyp r2 = ucl_sqrt(rsq2);\n"
"        numtyp r2inv = ucl_rsqrt(rsq2);\n"
"        numtyp fi[3], fj[3], fk[3];\n"
"        numtyp4 ts1_param, ts2_param, ts4_param;\n"
"        ts1_param = ts1[jikparam]; \n"
"        lam3 = ts1_param.z;\n"
"        powermint = ts1_param.w;\n"
"        ts2_param = ts2[jikparam]; \n"
"        bigr = ts2_param.z;\n"
"        bigd = ts2_param.w;\n"
"        ts4_param = ts4[jikparam]; \n"
"        c = ts4_param.x;\n"
"        d = ts4_param.y;\n"
"        h = ts4_param.z;\n"
"        gamma = ts4_param.w;\n"
"        attractive(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                   prefactor_ji, r1, r1inv, r2, r2inv, mdelr1, delr2, fi, fj, fk);\n"
"        f.x += fj[0];\n"
"        f.y += fj[1];\n"
"        f.z += fj[2];\n"
"        virial[0] += TWOTHIRD*(mdelr1[0]*fj[0] + delr2[0]*fk[0]);\n"
"        virial[1] += TWOTHIRD*(mdelr1[1]*fj[1] + delr2[1]*fk[1]);\n"
"        virial[2] += TWOTHIRD*(mdelr1[2]*fj[2] + delr2[2]*fk[2]);\n"
"        virial[3] += TWOTHIRD*(mdelr1[0]*fj[1] + delr2[0]*fk[1]);\n"
"        virial[4] += TWOTHIRD*(mdelr1[0]*fj[2] + delr2[0]*fk[2]);\n"
"        virial[5] += TWOTHIRD*(mdelr1[1]*fj[2] + delr2[1]*fk[2]);\n"
"        \n"
"        int idx = nbor_k;\n"
"        if (dev_packed==dev_nbor) idx -= n_stride;\n"
"        acctyp4 zeta_jk = zetaij[idx]; \n"
"        numtyp prefactor_jk = zeta_jk.y;\n"
"        int jkiparam=elem2param[jtype*nelements*nelements+ktype*nelements+itype];\n"
"        ts1_param = ts1[jkiparam]; \n"
"        lam3 = ts1_param.z;\n"
"        powermint = ts1_param.w;\n"
"        ts2_param = ts2[jkiparam]; \n"
"        bigr = ts2_param.z;\n"
"        bigd = ts2_param.w;\n"
"        ts4_param = ts4[jkiparam]; \n"
"        c = ts4_param.x;\n"
"        d = ts4_param.y;\n"
"        h = ts4_param.z;\n"
"        gamma = ts4_param.w;\n"
"        attractive(bigr, bigd, powermint, lam3, c, d, h, gamma,\n"
"                   prefactor_jk, r2, r2inv, r1, r1inv, delr2, mdelr1, fi, fj, fk);\n"
"        f.x += fk[0];\n"
"        f.y += fk[1];\n"
"        f.z += fk[2];\n"
"        virial[0] += TWOTHIRD*(delr2[0]*fj[0] + mdelr1[0]*fk[0]);\n"
"        virial[1] += TWOTHIRD*(delr2[1]*fj[1] + mdelr1[1]*fk[1]);\n"
"        virial[2] += TWOTHIRD*(delr2[2]*fj[2] + mdelr1[2]*fk[2]);\n"
"        virial[3] += TWOTHIRD*(delr2[0]*fj[1] + mdelr1[0]*fk[1]);\n"
"        virial[4] += TWOTHIRD*(delr2[0]*fj[2] + mdelr1[0]*fk[2]);\n"
"        virial[5] += TWOTHIRD*(delr2[1]*fj[2] + mdelr1[1]*fk[2]);\n"
"      }\n"
"    } \n"
"    #ifdef THREE_CONCURRENT\n"
"    store_answers(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                  eflag,vflag,ans,engv);\n"
"    #else\n"
"    store_answers_p(f,energy,virial,ii,inum,tid,tpa_sq,offset,\n"
"                    eflag,vflag,ans,engv);\n"
"    #endif\n"
"  } \n"
"}\n"
;
